#! /bin/sh -f
M=$1
ANGLE=$2

#
# extract all the edges of the 3-D volume mesh
#
echo advautomesh_tetra3d_edge
advautomesh_tetra3d_edge ${M}.node ${M}.element \
    ${M}.el_ed ${M}.ed_vt
#
# extract all the faces of the volume mesh, 
#   also the element neighbor relationship
#
echo advautomesh_tetra3d_face
advautomesh_tetra3d_face ${M}.node ${M}.element \
    ${M}.face ${M}.el_fc ${M}.el_nb
#
# extract all the faces on the boundary
#
echo advautomesh_tetra3d_boundary_face
advautomesh_tetra3d_boundary_face ${M}.node ${M}.element \
    ${M}.bd_fc
#
# extract a boundary surface mesh (${M}_B.* files)
#
echo advautomesh_tetra3d_boundary2
advautomesh_tetra3d_boundary2 ${M}.node ${M}.element \
    ${M}.bd_fc \
    ${M}_B.node ${M}_B.element ${M}_B.src_nd
#
# extract all the edges of the surface mesh, 
#   also the element neighbor relationship
#
echo advautomesh_tri3d_edge
advautomesh_tri3d_edge ${M}_B.node ${M}_B.element \
    ${M}_B.edge ${M}_B.el_ed ${M}_B.el_nb ${M}_B.ed_vt
#
# make groups of the surface mesh (face grouping)
#
echo advautomesh_tri3d_group
advautomesh_tri3d_group  ${M}_B.node ${M}_B.element \
    ${M}_B.edge ${M}_B.el_ed ${M}_B.el_nb ${M}_B.ed_vt ${ANGLE} \
    ${M}_B.el_gr ${M}_B.ed_fr ${M}_B.frame \
    ${M}_B.ed_fr_gr ${M}_B.nd_fr_vt
