/* advautomesh_h_attrib2msh.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



#define MAX_OBJECTS 1000000

int NObjects;
int Object_attributeId[MAX_OBJECTS];
int NAttributes;



void ReadAttributeFile (const char *fileName)
{
  FILE *fp;
  int iObject;
  int maxAttributeId = -1;

  assert(NObjects == 0);

  fp = fopen (fileName, "r");
  assert(fp != NULL);

  fscanf (fp, "%d", 
	  &NObjects);
  
  for (iObject = 0; iObject < NObjects; iObject++) {
    int objectId;
    int attributeId;

    fscanf (fp, "%d %d", 
	    &objectId,
	    &attributeId);
    assert(objectId == iObject);
    assert(0 <= attributeId);

    Object_attributeId[iObject] = attributeId;

    if (maxAttributeId < attributeId) {
      maxAttributeId = attributeId;
    }
  }
  
  fclose (fp);
  
  NAttributes = maxAttributeId + 1;
}

void WriteMshFile (const char *fileName)
{
  FILE *fp;
  int iAttribute;
  int iObject;

  assert(0 <= NObjects);
  assert(0 <= NAttributes);

  fp = fopen (fileName, "w");
  assert(fp != NULL);

  fprintf (fp, "%d\n", 
	   NAttributes);
  
  for (iAttribute = 0; iAttribute < NAttributes; iAttribute++) {
    int count;

    count = 0;
    for (iObject = 0; iObject < NObjects; iObject++) {
      if (Object_attributeId[iObject] == iAttribute) {
	count++;
      }
    }
    fprintf (fp, "%d\n", 
	     count);
    
    for (iObject = 0; iObject < NObjects; iObject++) {
      if (Object_attributeId[iObject] == iAttribute) {
	fprintf (fp, "%d\n", 
		 iObject); 
      }
    }
  }

  fclose (fp);
}



int main (int argc, char *argv[])
{
  if (argc != 3) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_attrib2msh  attribute_file \n"
       "        msh_file_OUT \n");
    exit (1);
  }

  ReadAttributeFile (argv[1]);

  WriteMshFile (argv[2]);

  return 0;
}
