/* advautomesh_h_init_attrib.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



#define MAX_OBJECTS 1000000

int NObjects;



void ReadObjectFile (const char *fileName)
{
  FILE *fp;

  fp = fopen (fileName, "r");
  assert(fp != NULL);

  fscanf (fp, "%d", 
	  &NObjects);

  fclose (fp);
}

void WriteAttributeFile (const char *fileName)
{
  FILE *fp;
  int iObject;

  assert(0 <= NObjects);

  fp = fopen (fileName, "w");
  assert(fp != NULL);

  fprintf (fp, "%d\n", 
	   NObjects);
  
  for (iObject = 0; iObject < NObjects; iObject++) {
    fprintf (fp, "%d   %d\n", 
	     iObject, 
	     0); 
  }
  
  fclose (fp);
}



int main (int argc, char *argv[])
{
  if (argc != 3) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_init_attrib  object_file \n"
       "        attribute_file_OUT \n");
    exit (1);
  }

  ReadObjectFile (argv[1]);

  WriteAttributeFile (argv[2]);

  return 0;
}
