/* advautomesh_h_hexa3d_node_dof_bc2adv.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include <Adv/AdvDocument.h>



int main (int argc, char *argv[])
{
  char *fegaLabel;
  FILE *fp;
  AdvDocFile *advFile;
  AdvDocument *doc;
  int nItems;
  int iItem;
  adv_off_t offset;
  
  if (argc != 4) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_hexa3d_node_dof_bc2adv \n"
       "     node_dof_bc_file  FEGA_label \n"
       "     advio_file_OUT \n");
    exit (1);
  }
  
  fp = fopen (argv[1], "r");
  assert(fp != NULL);

  fegaLabel = argv[2];
  
  advFile = adv_dio_file_open (argv[3], "c");
  doc = adv_dio_create (advFile, adv_dio_make_documentid (fegaLabel));

  fscanf (fp, "%d", &nItems);
  
  adv_dio_set_property (doc, "content_type", "FEGenericAttribute");
  adv_dio_set_property_int32 (doc, "num_items", nItems);
  adv_dio_set_property (doc, "fega_type", "NodeVariable");
  adv_dio_set_property (doc, "label", fegaLabel);
  adv_dio_set_property (doc, "format", "i4f8");
  adv_dio_set_property_int32 (doc, "index_byte", 4);
  
  offset = 0;
  for (iItem = 0; iItem < nItems; iItem++) {
    int itemId;
    int nodeId;
    int dofId;
    double value;
    
    fscanf (fp, "%d %d %d %lf", 
	    &itemId, 
	    &nodeId, &dofId, &value); 
    assert(itemId == iItem);
    assert(0 <= nodeId);
    assert(0 <= dofId);
    assert(dofId < 3);
    
    offset += adv_dio_write_int32 (doc, offset, nodeId);
    offset += adv_dio_write_int32 (doc, offset, dofId);
    offset += adv_dio_write_float64 (doc, offset, value);
  }
  
  adv_dio_close (doc);
  adv_dio_file_close (advFile);

  fclose (fp);

  return 0;
}


