/* advautomesh_h_quad2d_const_node_vector_bc.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



int main (int argc, char *argv[])
{
  FILE *inFp;
  FILE *outFp;
  double valueX, valueY;
  int nItems;
  int iItem;

  if (argc != 5) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_quad2d_const_node_vector_bc \n"
       "        node_list_file  valueX  valueY \n"
       "        node_vector_bc_file_OUT \n");
    exit (1);
  }

  inFp = fopen (argv[1], "r");
  assert(inFp != NULL);

  valueX = atof (argv[2]);
  valueY = atof (argv[3]);

  outFp = fopen (argv[4], "w");
  assert(inFp != NULL);

  fscanf (inFp, "%d",
	  &nItems);
  assert(0 <= nItems);
  
  fprintf (outFp, "%d\n",
	   nItems);

  for (iItem = 0; iItem < nItems; iItem++) {
    int itemId;
    int nodeId;
    
    fscanf (inFp, "%d %d",
	    &itemId,
	    &nodeId);
    assert(itemId == iItem);
    assert(0 <= nodeId);
    
    fprintf (outFp, "%d   %d %f %f\n",
	     iItem, 
	     nodeId, valueX, valueY);
  }

  fclose (inFp);
  fclose (outFp);
  
  return 0;
}


