/* advautomesh_h_tetra3d_const_face_dof_bc.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



int main (int argc, char *argv[])
{
  FILE *inFp;
  FILE *outFp;
  int dofId;
  double value;
  int nItems;
  int iItem;

  if (argc != 5) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_tetra3d_const_face_dof_bc \n"
       "        face_list_file  dofId  value \n"
       "        face_dof_bc_file_OUT \n");
    exit (1);
  }

  inFp = fopen (argv[1], "r");
  assert(inFp != NULL);

  dofId = atoi (argv[2]);
  value = atof (argv[3]);

  outFp = fopen (argv[4], "w");
  assert(inFp != NULL);

  fscanf (inFp, "%d",
	  &nItems);
  assert(0 <= nItems);
  
  fprintf (outFp, "%d\n",
	   nItems);

  for (iItem = 0; iItem < nItems; iItem++) {
    int itemId;
    int faceId;
    
    fscanf (inFp, "%d %d",
	    &itemId,
	    &faceId);
    assert(itemId == iItem);
    assert(0 <= faceId);
    
    fprintf (outFp, "%d   %d %d %f\n",
	     iItem, 
	     faceId, dofId, value);
  }

  fclose (inFp);
  fclose (outFp);
  
  return 0;
}


