/* advautomesh_h_tetra3d_const_face_vector_bc.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



int main (int argc, char *argv[])
{
  FILE *inFp;
  FILE *outFp;
  double valueX, valueY, valueZ;
  int nItems;
  int iItem;

  if (argc != 6) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_tetra3d_const_face_vector_bc \n"
       "        face_list_file  valueX  valueY  valueZ \n"
       "        face_vector_bc_file_OUT \n");
    exit (1);
  }

  inFp = fopen (argv[1], "r");
  assert(inFp != NULL);

  valueX = atof (argv[2]);
  valueY = atof (argv[3]);
  valueZ = atof (argv[4]);

  outFp = fopen (argv[5], "w");
  assert(inFp != NULL);

  fscanf (inFp, "%d",
	  &nItems);
  assert(0 <= nItems);
  
  fprintf (outFp, "%d\n",
	   nItems);

  for (iItem = 0; iItem < nItems; iItem++) {
    int itemId;
    int faceId;
    
    fscanf (inFp, "%d %d",
	    &itemId,
	    &faceId);
    assert(itemId == iItem);
    assert(0 <= faceId);
    
    fprintf (outFp, "%d   %d %f %f %f\n",
	     iItem, 
	     faceId, valueX, valueY, valueZ);
  }

  fclose (inFp);
  fclose (outFp);
  
  return 0;
}


