/* advautomesh_h_tetra3d_node_vector_bc2dof_bc.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



int main (int argc, char *argv[])
{
  FILE *inFp;
  FILE *outFp;
  int nItems;
  int iItem;

  if (argc != 3) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_tetra3d_node_vector_bc2dof_bc \n"
       "        node_vector_bc_file \n"
       "        node_dof_bc_file_OUT \n");
    exit (1);
  }

  inFp = fopen (argv[1], "r");
  assert(inFp != NULL);

  outFp = fopen (argv[2], "w");
  assert(inFp != NULL);

  fscanf (inFp, "%d",
	  &nItems);
  assert(0 <= nItems);
  
  fprintf (outFp, "%d\n",
	   nItems * 3);

  for (iItem = 0; iItem < nItems; iItem++) {
    int itemId;
    int nodeId;
    double valueX, valueY, valueZ;
    
    fscanf (inFp, "%d %d %lf %lf %lf",
	    &itemId,
	    &nodeId, &valueX, &valueY, &valueZ);
    assert(itemId == iItem);
    assert(0 <= nodeId);
    
    fprintf (outFp, "%d   %d 0 %f\n",
	     iItem * 3 + 0, 
	     nodeId, valueX);
    fprintf (outFp, "%d   %d 1 %f\n",
	     iItem * 3 + 1, 
	     nodeId, valueY);
    fprintf (outFp, "%d   %d 2 %f\n",
	     iItem * 3 + 2, 
	     nodeId, valueZ);
  }

  fclose (inFp);
  fclose (outFp);
  
  return 0;
}


