/* advautomesh_h_tetra3d_twc_insert.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



/************************
	 Other Data
*************************/

/* Crack */

double Vertex0_coord[3];
double Vertex1_coord[3];
double Vertex2_coord[3];
double Vertex3_coord[3];



void ReadThroughWallCrackFile (const char *fileName)
{
  FILE *fp;
  
  fp = fopen (fileName, "r");
  assert(fp != NULL);
  
  fscanf (fp, "%lf %lf %lf", 
	  &Vertex0_coord[0], &Vertex0_coord[1], &Vertex0_coord[2]);
  fscanf (fp, "%lf %lf %lf", 
	  &Vertex1_coord[0], &Vertex1_coord[1], &Vertex1_coord[2]);
  fscanf (fp, "%lf %lf %lf", 
	  &Vertex2_coord[0], &Vertex2_coord[1], &Vertex2_coord[2]);
  fscanf (fp, "%lf %lf %lf", 
	  &Vertex3_coord[0], &Vertex3_coord[1], &Vertex3_coord[2]);

  fclose (fp);
}

void WritePointFile (const char *fileName)
{
  FILE *fp;

  fp = fopen (fileName, "w");
  assert(fp != NULL);
  
  fprintf (fp, "%d\n", 
	   0);

  fclose (fp);
}

void WriteSegFile (const char *fileName)
{
  FILE *fp;

  fp = fopen (fileName, "w");
  assert(fp != NULL);
  
  fprintf (fp, "%d\n", 
	   1);
  
  fprintf (fp, "%d   %22.15f %22.15f %22.15f   %22.15f %22.15f %22.15f\n", 
	   0,
	   Vertex0_coord[0], Vertex0_coord[1], Vertex0_coord[2],
	   Vertex1_coord[0], Vertex1_coord[1], Vertex1_coord[2]);

  fclose (fp);
}

void WriteTriFile (const char *fileName)
{
  FILE *fp;

  fp = fopen (fileName, "w");
  assert(fp != NULL);
  
  fprintf (fp, "%d\n", 
	   2);
  
  fprintf 
    (fp, 
     "%d   %22.15f %22.15f %22.15f   %22.15f %22.15f %22.15f   %22.15f %22.15f %22.15f\n", 
     0,
     Vertex0_coord[0], Vertex0_coord[1], Vertex0_coord[2],
     Vertex1_coord[0], Vertex1_coord[1], Vertex1_coord[2],
     Vertex2_coord[0], Vertex2_coord[1], Vertex2_coord[2]);
  fprintf 
    (fp, 
     "%d   %22.15f %22.15f %22.15f   %22.15f %22.15f %22.15f   %22.15f %22.15f %22.15f\n", 
     1,
     Vertex2_coord[0], Vertex2_coord[1], Vertex2_coord[2],
     Vertex3_coord[0], Vertex3_coord[1], Vertex3_coord[2],
     Vertex0_coord[0], Vertex0_coord[1], Vertex0_coord[2]);

  fclose (fp);
}



int main (int argc, char *argv[])
{
  if (argc != 5) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_tetra3d_twc_insert  through_wall_crack_file \n"
       "        point_file_OUT  seg_file_OUT  tri_file_OUT \n");
    exit (1);
  }

  ReadThroughWallCrackFile (argv[1]);

  WritePointFile (argv[2]);
  WriteSegFile (argv[3]);
  WriteTriFile (argv[4]);

  return 0;
}




