/* polygon.h */



/************************
	 Basic
*************************/

extern double Eps;



/********************************
         Polygon Data
********************************/

/* Polygon */

extern int NPolygons;
extern int Polygon_nLoops[MAX_POLYGONS];
extern int Polygon_nVertexs[MAX_POLYGONS][MAX_POLYGON_LOOPS];
extern double Polygon_vertexs
[MAX_POLYGONS][MAX_POLYGON_LOOPS][MAX_POLYGON_VERTEXS][3];

int AddNewPolygon (void);

int AddNewLoopIntoPolygon (int polygonId);

void AddNewVertexIntoPolygon 
(int polygonId,
 int loopId,
 double x, double y, double z);

void InverseLoop 
(int polygonId,
 int loopId);

void WritePolygonFile (const char *fileName);



/********************************
     Axis-aligned Polygon
********************************/

int MakeXYPolygonWith2Points 
(double originX, double originY,
 double extentX, double extentY,
 double z,
 int clockWiseFlag);

int MakeYZPolygonWith2Points 
(double originY, double originZ,
 double extentY, double extentZ,
 double x,
 int clockWiseFlag);

int MakeZXPolygonWith2Points 
(double originZ, double originZ,
 double extentX, double extentX,
 double y,
 int clockWiseFlag);



/********************************
     Axis-aligned Primitive
********************************/

void MakeBox 
(double originX, double originY, double originZ,
 double extentX, double extentY, double extentZ);

