#! /bin/sh -f

# The following 5 gm_polygon files are required.
#   all.gm_polygon, out.gm_polygon, other.gm_polygon, 
#     in0.gm_polygon, in1.gm_polygon, in2.gm_polygon
#
# Before running this script, 
#   ./make_geometry.sh
#

ALL_GM=all
IN0_GM=in0
IN1_GM=in1
IN2_GM=in2
OUT_GM=out
OTHER_GM=other
SIZE=0.1



advautomesh_h_tetra3d_gm_face_node \
    $ALL_GM.gm_point  $ALL_GM.gm_edge  $ALL_GM.gm_face  $SIZE \
    all_bnd.node
advautomesh_h_tetra3d_domain_node2 \
    all_bnd.node  $SIZE  \
    all_all.node
advautomesh_h_tetra3d_delaunay2 \
    all_all.node \
    all_all.element
advautomesh_h_tetra3d_swap \
    all_all.node  all_all.element  $ALL_GM.gm_tri \
    all_swap.node  all_swap.element

advautomesh_h_tetra3d_element_center \
    all_swap.node  all_swap.element \
    all_swap.gm_point
advautoage_h_gm3d_tri_inout \
    $OUT_GM.gm_tri  all_swap.gm_point \
    all_swap.gm_inout
advautomesh_h_tetra3d_inout2list \
    all_swap.gm_inout \
    all_swap.el_list
advautomesh_h_tetra3d_extract  \
    all_swap.node  all_swap.element  all_swap.el_list \
    all.node  all.element

advautomesh_tetra3d_mesh_only.sh \
    all  30



advautomesh_h_tetra3d_element_center \
    all.node  all.element \
    all.gm_point



advautoage_h_gm3d_tri_inout \
    $IN0_GM.gm_tri  all.gm_point \
    all_in0.gm_inout
advautomesh_h_tetra3d_inout2list \
    all_in0.gm_inout \
    all_in0.el_list
advautomesh_h_tetra3d_extract  \
    all.node  all.element  all_in0.el_list \
    in0.node  in0.element

advautomesh_tetra3d_mesh_only.sh \
    in0  30



advautoage_h_gm3d_tri_inout \
    $IN1_GM.gm_tri  all.gm_point \
    all_in1.gm_inout
advautomesh_h_tetra3d_inout2list \
    all_in1.gm_inout \
    all_in1.el_list
advautomesh_h_tetra3d_extract  \
    all.node  all.element  all_in1.el_list \
    in1.node  in1.element

advautomesh_tetra3d_mesh_only.sh \
    in1  30



advautoage_h_gm3d_tri_inout \
    $IN2_GM.gm_tri  all.gm_point \
    all_in2.gm_inout
advautomesh_h_tetra3d_inout2list \
    all_in2.gm_inout \
    all_in2.el_list
advautomesh_h_tetra3d_extract  \
    all.node  all.element  all_in2.el_list \
    in2.node  in2.element

advautomesh_tetra3d_mesh_only.sh \
    in2  30



advautoage_h_gm3d_tri_inout \
    $OTHER_GM.gm_tri  all.gm_point \
    all_other.gm_inout
advautomesh_h_tetra3d_inout2list \
    all_other.gm_inout \
    all_other.el_list
advautomesh_h_tetra3d_extract  \
    all.node  all.element  all_other.el_list \
    other.node  other.element

advautomesh_tetra3d_mesh_only.sh \
    other  30



advautomesh_tetra3d_generate_mid_node  \
    all.node  all.element  all.ed_vt  all.el_ed  \
    quadratic.node  quadratic.element  quadratic.mng_src_nd
~/work/automesh/interface/TetMesh/advautomesh_export_ADVENTURE_msh  \
    tetra10n  quadratic.node  quadratic.element  \
    CASE.msh

advautomesh_h_init_attrib  \
    all.element \
    tmp.attrib
advautomesh_h_add_attrib  \
    tmp.attrib  all_in0.el_list \
    tmp.attrib
advautomesh_h_add_attrib  \
    tmp.attrib  all_in1.el_list \
    tmp.attrib
advautomesh_h_add_attrib  \
    tmp.attrib  all_in2.el_list \
    tmp.attrib
advautomesh_h_attrib2msh  \
    tmp.attrib  tmp.msh

cat  CASE.msh  tmp.msh  >  CASE_multi.msh
