/* make_topology.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



/************************
        Mesh
*************************/

/* Node */

#define MAX_NODES 1000000

int NNodes;



void ReadNodeFile (const char *fileName)
{
  FILE *fp;
  int iNode;
  
  assert(NNodes == 0);
  
  fp = fopen (fileName, "r");
  assert(fp != NULL);
  
  fscanf (fp, "%d", 
	  &NNodes);
  assert(0 <= NNodes);
  assert(NNodes <= MAX_NODES);
  
  fclose (fp);
}

void WriteTopologyFile (const char *fileName)
{
  FILE *fp;
  int iNode;
  
  assert(0 < NNodes);

  fp = fopen (fileName, "w");
  assert(fp != NULL);

  fprintf (fp, "%d\n", 
	   NNodes);
  
  for (iNode = 0; iNode < NNodes; iNode++) {
    fprintf (fp, "%d   0\n", 
	     iNode);
  }

  fclose (fp);
}



int main (int argc, char *argv[])
{
  if (argc != 3) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " make_topology  node_file  \n"
       "        topology_file_OUT \n");
    exit (1);
  }

  ReadNodeFile (argv[1]);
  
  WriteTopologyFile (argv[2]);

  return 0;
}
