/* advautomesh_h_tri2d_const_edge_scalar_bc.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



int main (int argc, char *argv[])
{
  FILE *inFp;
  FILE *outFp;
  double value;
  int nItems;
  int iItem;

  if (argc != 4) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_tri2d_const_edge_scalar_bc \n"
       "        edge_list_file  value \n"
       "        edge_scalar_bc_file_OUT \n");
    exit (1);
  }

  inFp = fopen (argv[1], "r");
  assert(inFp != NULL);

  value = atof (argv[2]);

  outFp = fopen (argv[3], "w");
  assert(inFp != NULL);

  fscanf (inFp, "%d",
	  &nItems);
  assert(0 <= nItems);
  
  fprintf (outFp, "%d\n",
	   nItems);

  for (iItem = 0; iItem < nItems; iItem++) {
    int itemId;
    int edgeId;
    
    fscanf (inFp, "%d %d",
	    &itemId,
	    &edgeId);
    assert(itemId == iItem);
    assert(0 <= edgeId);
    
    fprintf (outFp, "%d   %d %f\n",
	     iItem, 
	     edgeId, value);
  }

  fclose (inFp);
  fclose (outFp);
  
  return 0;
}


