/* advautomesh_h_tri2d_ec_insert.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



/************************
	 Other Data
*************************/

/* Crack */

double CrackTipX, CrackTipY;
double CrackEndX, CrackEndY;



void ReadEdgeCrackFile (const char *fileName)
{
  FILE *fp;
  
  fp = fopen (fileName, "r");
  assert(fp != NULL);
  
  fscanf (fp, "%lf %lf", 
	  &CrackTipX, &CrackTipY);
  fscanf (fp, "%lf %lf", 
	  &CrackEndX, &CrackEndY);

  fclose (fp);
}

void WritePointFile (const char *fileName)
{
  FILE *fp;

  fp = fopen (fileName, "w");
  assert(fp != NULL);
  
  fprintf (fp, "1\n");
  fprintf (fp, "0   %22.15e %22.15e\n", 
	   CrackTipX, CrackTipY);

  fclose (fp);
}

void WriteSegmentFile (const char *fileName)
{
  FILE *fp;

  fp = fopen (fileName, "w");
  assert(fp != NULL);
  
  fprintf (fp, "1\n");
  fprintf (fp, "0   %22.15e %22.15e %22.15e %22.15e\n", 
	   CrackTipX, CrackTipY,
	   CrackEndX, CrackEndY);

  fclose (fp);
}



int main (int argc, char *argv[])
{
  if (argc != 4) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_tri2d_ec_insert  edge_crack_file \n"
       "        point_file_OUT  segment_file_OUT \n");
    exit (1);
  }

  ReadEdgeCrackFile (argv[1]);

  WritePointFile (argv[2]);
  WriteSegmentFile (argv[3]);

  return 0;
}
