/* advautomesh_h_tri2d_inout2list.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



/************************
	 Mesh
*************************/

/* Element */

#define MAX_ELEMENTS 1000000

int NElements;
int Element_inoutType[MAX_ELEMENTS];



void ReadElementInoutFile (const char *fileName)
{
  FILE *fp;
  int iElement;

  assert(NElements == 0);
  
  fp = fopen (fileName, "r");
  assert(fp != NULL);
  
  fscanf (fp, "%d", 
	  &NElements);
  assert(0 < NElements);
  assert(NElements <= MAX_ELEMENTS);
  
  for (iElement = 0; iElement < NElements; iElement++) {
    int elementId;
    int inoutType;
    
    fscanf (fp, "%d %d", 
	    &elementId,
	    &inoutType); 
    assert(elementId == iElement);
    assert(inoutType == 0
	   || inoutType == 1);
    
    Element_inoutType[iElement] = inoutType;
  }
  
  fclose (fp);
}

void WriteElementListFile (const char *fileName)
{
  FILE *fp;
  int iElement;
  int count;

  assert(0 < NElements);

  count = 0;
  for (iElement = 0; iElement < NElements; iElement++) {
    if (Element_inoutType[iElement] == 1) {
      count++;
    }
  }

  fp = fopen (fileName, "w");
  assert(fp != NULL);

  fprintf (fp, "%d\n", 
	   count);
  
  count = 0;
  for (iElement = 0; iElement < NElements; iElement++) {
    if (Element_inoutType[iElement] == 1) {
      fprintf (fp, "%d   %d\n", 
	       count, iElement); 
      count++;
    }
  }
  
  fclose (fp);
}



int main (int argc, char *argv[])
{
  if (argc != 3) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_tri2d_inout2list \n"
       "        element_inout_file \n"
       "        element_list_file_OUT \n");
    exit (1);
  }

  ReadElementInoutFile (argv[1]);
  WriteElementListFile (argv[2]);

  return 0;
}
