/* advautomesh_h_tri2d_node_scalar_bc2dof_bc.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>



int main (int argc, char *argv[])
{
  FILE *inFp;
  FILE *outFp;
  int nItems;
  int iItem;

  if (argc != 3) {
    fprintf 
      (stderr, 
       " Usage : \n"
       " advautomesh_h_tri2d_node_scalar_bc2dof_bc \n"
       "        node_scalar_bc_file \n"
       "        node_dof_bc_file_OUT \n");
    exit (1);
  }

  inFp = fopen (argv[1], "r");
  assert(inFp != NULL);

  outFp = fopen (argv[2], "w");
  assert(inFp != NULL);

  fscanf (inFp, "%d",
	  &nItems);
  assert(0 <= nItems);
  
  fprintf (outFp, "%d\n",
	   nItems);

  for (iItem = 0; iItem < nItems; iItem++) {
    int itemId;
    int nodeId;
    double value;
    
    fscanf (inFp, "%d %d %lf",
	    &itemId,
	    &nodeId, &value);
    assert(itemId == iItem);
    assert(0 <= nodeId);
    
    fprintf (outFp, "%d   %d %f\n",
	     iItem, 
	     nodeId, value);
  }

  fclose (inFp);
  fclose (outFp);
  
  return 0;
}


