#
# generate document files
#   from POD to text, HTML, LaTeX, ps and pdf files
#



#
# copy POD files
#
cp ../command/*.pod .
cp ../viewer/*.pod .
cp ../file_format/*.pod .



#
# generate data about command
#
./generate.sh boundary_node
./generate.sh domain_node2
./generate.sh delaunay3
./generate.sh crack
./generate.sh laplacian
./generate.sh renumber_node
./generate.sh bucket_renumber
./generate.sh mid_node  
./generate.sh divide
./generate.sh refine
./generate.sh extract  
./generate.sh remove  
./generate.sh extract_node
./generate.sh edge2
./generate.sh neighbor  
./generate.sh topology
./generate.sh frame
./generate.sh property  
./generate.sh element_center  
./generate.sh check_node_duplication
./generate.sh isoline
./generate.sh grid
./generate.sh sample
./generate.sh sample_scalar
./generate.sh sample_vector

#
# generate data about viewer
#
./generate.sh mesh_view
./generate.sh node_view
./generate.sh frame_view
./generate.sh topology_view
./generate.sh node_crack_view
./generate.sh contour_view
./generate.sh isoline_view
./generate.sh deform_view
./generate.sh arrow_view

#
# generate data about file format
#
./generate.sh node_file
./generate.sh element_file
./generate.sh element_6node_file
./generate.sh edge_file
./generate.sh edge_vertex_file
./generate.sh element_edge_file
./generate.sh element_neighbor_file



#
# process LaTeX
#
platex main.tex
platex main.tex
pdvips -o main.ps main.dvi
ps2pdf main.ps main.pdf



