/* AutoMESH */

#ifndef __AUTOMESH__
#define __AUTOMESH__

#ifdef __cplusplus
#include <cstdio>
extern "C" {
#endif



/* Basic */

#include "automesh_base.h"
#include "automesh_shape.h"
  
/* 2-D Class */

#include "automesh_node2d.h"
#include "automesh_node_scalar2d.h"
#include "automesh_node_vector2d.h"

#include "automesh_frame2d.h"

/* 2-D Class : Volume Mesh */

#include "automesh_volume_element2d.h"
#include "automesh_volume_edge2d.h"
#include "automesh_volume_boundary_edge2d.h"

#include "automesh_volume_sample2d.h"
#include "automesh_volume_particle2d.h"

#include "automesh_volume_divider2d.h"
#include "automesh_volume_mid_node_generator2d.h"
#include "automesh_volume_mid_node_remover2d.h"
#include "automesh_volume_extractor2d.h"

/* 3-D Class */

#include "automesh_node3d.h"
#include "automesh_node_scalar3d.h"
#include "automesh_node_vector3d.h"

#include "automesh_frame3d.h"

/* 3-D Class : Surface Mesh */

#include "automesh_surface_element3d.h"
#include "automesh_surface_edge3d.h"
#include "automesh_surface_boundary_edge3d.h"

#include "automesh_surface_divider3d.h"
#include "automesh_surface_mid_node_generator3d.h"
#include "automesh_surface_mid_node_remover3d.h"
#include "automesh_surface_extractor3d.h"
#include "automesh_surface_grouper3d.h"

/* 3-D Class : Volume Mesh */

#include "automesh_volume_element3d.h"
#include "automesh_volume_edge3d.h"
#include "automesh_volume_face3d.h"
#include "automesh_volume_boundary_face3d.h"

#include "automesh_volume_section3d.h"
#include "automesh_volume_section3d2.h"
#include "automesh_volume_isosurface3d.h"
#include "automesh_volume_isosurface3d2.h"
#include "automesh_volume_sample3d.h"
#include "automesh_volume_particle3d.h"

#include "automesh_volume_boundary_maker3d.h"
#include "automesh_volume_boundary_maker3d2.h"
#include "automesh_volume_divider3d.h"
#include "automesh_volume_mid_node_generator3d.h"
#include "automesh_volume_mid_node_remover3d.h"
#include "automesh_volume_extractor3d.h"

#include "automesh_initialize.h"



#ifdef __cplusplus
}
#endif

#endif  /* __AUTOMESH__ */

