/* header file for automesh_base.c */

#ifndef __AUTOMESH_BASE__
#define __AUTOMESH_BASE__

/* Base Module */



/* Utility */

/* $B%(%i!<%a%C%;!<%8$rI=<($9$k!#(B */
void AutoMesh_Error (const char *msg);
/* $BCm0U!'(Babort$B$9$k!#(B */

/* $B7Y9p%a%C%;!<%8$rI=<($9$k!#(B */
void AutoMesh_Warning (const char *msg);



/* General */

/* 3$B$D$N(BID$B$r%=!<%H$9$k!#(B */
void AutoMesh_SortId3 
(int id0, int id1, int id2,
 int *minId_OUT, int *midId_OUT, int *maxId_OUT);

/* ID$B$N%Z%"F1;N$rHf3S$9$k!#(B */
int AutoMesh_IdIsEqual2 
(int id0_0, int id0_1,
 int id1_0, int id1_1);

/* ID$B$N;0$DAHF1;N$rHf3S$9$k!#(B */
int AutoMesh_IdIsEqual3 
(int id0_0, int id0_1, int id0_2,
 int id1_0, int id1_1, int id1_2);



/* 2-D Geometry */
/* NO-TEST */

/* $B%Y%/%H%k$ND9$5$r5a$a$k!#(B */
double AutoMesh_Length2D 
(double x, double y);

/* $BFsE@4V$N5wN%$r5a$a$k!#(B */
double AutoMesh_Distance2D 
(double x0, double y0,
 double x1, double y1);

/* $B%Y%/%H%k$rD9$5(B1$B$K@55,2=$9$k!#(B */
void AutoMesh_GetNormalizedVector2D 
(double x, double y,
 double *nx_OUT, double *ny_OUT);

/* 2$B$D$N%Y%/%H%k$NFb@Q$r5a$a$k!#(B */
double AutoMesh_ScalarProduct2D 
(double x0, double y0,
 double x1, double y1);

/* $B;03Q7A$NLL@Q$r5a$a$k!#(B($BId9fIU(B) */
double AutoMesh_SignedTriArea2D
(double x0, double y0,
 double x1, double y1,
 double x2, double y2);


/* 3-D Geometry */

/* $B%Y%/%H%k$ND9$5$r5a$a$k!#(B */
double AutoMesh_Length3D 
(double x, double y, double z);

/* $BFsE@4V$N5wN%$r5a$a$k!#(B */
double AutoMesh_Distance3D 
(double x0, double y0, double z0,
 double x1, double y1, double z1);

/* $B%Y%/%H%k$rD9$5(B1$B$K@55,2=$9$k!#(B */
void AutoMesh_GetNormalizedVector3D 
(double x, double y, double z,
 double *nx_OUT, double *ny_OUT, double *nz_OUT);

/* 2$B$D$N%Y%/%H%k$NFb@Q$r5a$a$k!#(B */
double AutoMesh_ScalarProduct3D 
(double x0, double y0, double z0,
 double x1, double y1, double z1);

/* 2$B$D$N%Y%/%H%k$N30@Q$r5a$a$k!#(B */
void AutoMesh_GetVectorProduct3D 
(double x0, double y0, double z0,
 double x1, double y1, double z1,
 double *x_OUT, double *y_OUT, double *z_OUT);

/* $B;XDj%Y%/%H%k$K?bD>(B,$B$+$D8_$$$K?bD>$J(B2$B$D$N%Y%/%H%k$r5a$a$k!#(B */
void AutoMesh_GetAnyPerpendicularDirection3D
(double x, double y, double z,
 double *nx0_OUT, double *ny0_OUT, double *nz0_OUT,
 double *nx1_OUT, double *ny1_OUT, double *nz1_OUT);

/* $BJ?LL$KE@$rEj1F$9$k!#(B */
void AutoMesh_GetProjectedPointOnPlane3D
(double a, double b, double c, double d, 
 double x, double y, double z,
 double *px_OUT, double *py_OUT, double *pz_OUT);
/* a, b, c, d : $BJ?LL$NJ}Dx<0(B */

/* $B;MLLBN$NBN@Q$r5a$a$k!#(B($BId9fIU(B) */
double AutoMesh_SignedTetraVolume3D
(double x0, double y0, double z0,
 double x1, double y1, double z1,
 double x2, double y2, double z2,
 double x3, double y3, double z3);



#endif  /* __AUTOMESH_BASE__ */






