/* header file for automesh_frame2d.c */

#ifndef __AUTOMESH_FRAME2D__
#define __AUTOMESH_FRAME2D__



/* Frame2D */

/* $B%U%l!<%`%F!<%V%k%/%i%9(B */
/* ($BOH@~(B,$BNX3T@~(B) */
typedef struct _AutoMesh_Frame2D {
  AutoRes_Handle handle;

  AutoRes_Table *frames;  /* OWN */
  /* $B%U%l!<%`%F!<%V%k(B */
  AutoRes_Real1DColumn *frames_endPoint0;  /* [2] */
  /* $BC<E@:BI8%+%i%`(B0 */
  AutoRes_Real1DColumn *frames_endPoint1;  /* [2] */
  /* $BC<E@:BI8%+%i%`(B1 */
} AutoMesh_Frame2D;

AUTORES_DECLARE_HANDLE(AutoMesh_Frame2D)

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_Frame2D *AutoMesh_Frame2D_New (void);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_Frame2D_delete 
(AutoMesh_Frame2D *self);

/* $B;XDj$N%l%3!<%I?t$r@_Dj$9$k!#(B*/
/* $B$=$NJ,$N%l%3!<%I$,$^$H$a$F@8@.$5$l$k!#(B */
/* $B$3$l$^$G$K@8@.$5$l$?%+%i%`J,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */ 
AutoMesh_Frame2D_allocateFrames 
(AutoMesh_Frame2D *self,
 int nFrames);

/* $B;XDj?t$N%l%3!<%I$rM=Ls$9$k!#(B */
/* $B$?$@$7!"%l%3!<%I?t<+BN$O(B0$B$N$^$^!#(B */
/* $B$3$l$^$G$K@8@.$5$l$?%+%i%`J,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */ 
AutoMesh_Frame2D_reserveFrames 
(AutoMesh_Frame2D *self,
 int nFrames);

/* $B%l%3!<%I$r0l$D?75,$KDI2C$9$k!#(B */
/* $B$3$l$K$h$j!"%l%3!<%I?t$O(B1$B$DA}$($k!#(B */
int AutoMesh_Frame2D_addFrame 
(AutoMesh_Frame2D *self);
/* $B%l%3!<%I(BID$B$rJV$9!#(B($B<:GT$J$i(B-1) */

/* $BC<E@:BI8$N%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_Frame2D_makeEndPointsColumn 
(AutoMesh_Frame2D *self);

/* $B;XDj%l%3!<%I$NN>C<E@:BI8%U%#!<%k%ICM$r@_Dj$9$k!#(B */
void AutoMesh_Frame2D_setEndPointsAt 
(AutoMesh_Frame2D *self,
 int frameId,
 double x0, double y0,
 double x1, double y1);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_Frame2D_nFrames 
(AutoMesh_Frame2D *self);

/* $B;XDj%l%3!<%I$NN>C<E@:BI8%U%#!<%k%ICM$r5a$a$k!#(B */
void AutoMesh_Frame2D_getEndPointsAt 
(AutoMesh_Frame2D *self,
 int frameId,
 double *x0_OUT, double *y0_OUT,
 double *x1_OUT, double *y1_OUT);

/* $B%U%l!<%`%F!<%V%kA4BN$N@j$a$k6u4VNN0hHO0O$r5a$a$k!#(B */
void AutoMesh_Frame2D_getRange 
(AutoMesh_Frame2D *self,
 double *minX_OUT, double *minY_OUT,
 double *maxX_OUT, double *maxY_OUT);



#endif  /* __AUTOMESH_FRAME2D__ */
