/* automesh_initialize.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include <autores.h>

#include "automesh.h"



void AutoMesh_Initialize (void)
{
  /* 2-D Class */

  AutoMesh_Node2D_Initialize ();
  AutoMesh_NodeScalar2D_Initialize ();
  AutoMesh_NodeVector2D_Initialize ();

  AutoMesh_Frame2D_Initialize ();

  /* 2-D Class : Volume Mesh */

  AutoMesh_VolumeElement2D_Initialize ();
  AutoMesh_VolumeEdge2D_Initialize ();
  AutoMesh_VolumeBoundaryEdge2D_Initialize ();

  AutoMesh_VolumeSample2D_Initialize ();
  AutoMesh_VolumeParticle2D_Initialize ();

  AutoMesh_VolumeDivider2D_Initialize ();
  AutoMesh_VolumeMidNodeGenerator2D_Initialize ();
  AutoMesh_VolumeMidNodeRemover2D_Initialize ();
  AutoMesh_VolumeExtractor2D_Initialize ();

  /* 3-D Class */

  AutoMesh_Node3D_Initialize ();
  AutoMesh_NodeScalar3D_Initialize ();
  AutoMesh_NodeVector3D_Initialize ();

  AutoMesh_Frame3D_Initialize ();

  /* 3-D Class : Surface Mesh */

  AutoMesh_SurfaceElement3D_Initialize ();
  AutoMesh_SurfaceEdge3D_Initialize ();
  AutoMesh_SurfaceBoundaryEdge3D_Initialize ();

  AutoMesh_SurfaceDivider3D_Initialize ();
  AutoMesh_SurfaceMidNodeGenerator3D_Initialize ();
  AutoMesh_SurfaceMidNodeRemover3D_Initialize ();
  AutoMesh_SurfaceExtractor3D_Initialize ();
  AutoMesh_SurfaceGrouper3D_Initialize ();

  /* 3-D Class : Volume Mesh */

  AutoMesh_VolumeElement3D_Initialize ();
  AutoMesh_VolumeEdge3D_Initialize ();
  AutoMesh_VolumeFace3D_Initialize ();
  AutoMesh_VolumeBoundaryFace3D_Initialize ();

  AutoMesh_VolumeSection3D_Initialize ();
  AutoMesh_VolumeSection3D2_Initialize ();
  AutoMesh_VolumeIsosurface3D_Initialize ();
  AutoMesh_VolumeIsosurface3D2_Initialize ();
  AutoMesh_VolumeSample3D_Initialize ();
  AutoMesh_VolumeParticle3D_Initialize ();

  AutoMesh_VolumeBoundaryMaker3D_Initialize ();
  AutoMesh_VolumeBoundaryMaker3D2_Initialize ();
  AutoMesh_VolumeDivider3D_Initialize ();
  AutoMesh_VolumeMidNodeGenerator3D_Initialize ();
  AutoMesh_VolumeMidNodeRemover3D_Initialize ();
  AutoMesh_VolumeExtractor3D_Initialize ();
}
