/* header file for automesh_node3d.c */

#ifndef __AUTOMESH_NODE3D__
#define __AUTOMESH_NODE3D__



/* Node3D */

/* $B@aE@%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_Node3D {
  AutoRes_Handle handle;

  AutoRes_Table *nodes;  /* OWN */
  /* $B@aE@%F!<%V%k(B */
  AutoRes_Real1DColumn *nodes_coord;  /* [3] */
  /* $B:BI8%+%i%`(B */
  AutoRes_IntegerColumn *nodes_renumberedId;  
  /* $B%j%J%s%P%j%s%0MQ%+%i%`(B */
} AutoMesh_Node3D;

AUTORES_DECLARE_HANDLE(AutoMesh_Node3D)

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_Node3D *AutoMesh_Node3D_New (void);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_Node3D_delete 
(AutoMesh_Node3D *self);

/* $B;XDj$N%l%3!<%I?t$r@_Dj$9$k!#(B*/
/* $B$=$NJ,$N%l%3!<%I$,$^$H$a$F@8@.$5$l$k!#(B */
/* $B$3$l$^$G$K@8@.$5$l$?%+%i%`J,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */ 
AutoMesh_Node3D_allocateNodes 
(AutoMesh_Node3D *self,
 int nNodes);

/* $B;XDj?t$N%l%3!<%I$rM=Ls$9$k!#(B */
/* $B$?$@$7!"%l%3!<%I?t<+BN$O(B0$B$N$^$^!#(B */
/* $B$3$l$^$G$K@8@.$5$l$?%+%i%`J,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */ 
AutoMesh_Node3D_reserveNodes 
(AutoMesh_Node3D *self,
 int nNodes);

/* $B%l%3!<%I$r0l$D?75,$KDI2C$9$k!#(B */
/* $B$3$l$K$h$j!"%l%3!<%I?t$O(B1$B$DA}$($k!#(B */
int AutoMesh_Node3D_addNode 
(AutoMesh_Node3D *self);
/* $B%l%3!<%I(BID$B$rJV$9!#(B($B<:GT$J$i(B-1) */

/* $B:BI8$N%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_Node3D_makeCoordColumn 
(AutoMesh_Node3D *self);

/* $B;XDj%l%3!<%I$N:BI8%U%#!<%k%ICM$r@_Dj$9$k!#(B */
void AutoMesh_Node3D_setCoordAt 
(AutoMesh_Node3D *self,
 int nodeId,
 double x, double y, double z);

/* NO-TEST */
/* $B%j%J%s%P%j%s%0MQ%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_Node3D_makeRenumberedIdColumn 
(AutoMesh_Node3D *self);

/* NO-TEST */
/* $B%j%J%s%P%j%s%0MQ%+%i%`$r:o=|$9$k!#(B */
void AutoMesh_Node3D_deleteRenumberedId 
(AutoMesh_Node3D *self);

/* NO-TEST */
/* $B%j%J%s%P%j%s%0MQ%+%i%`$r=i4|2=$9$k!#(B */
void AutoMesh_Node3D_initializeRenumbering 
(AutoMesh_Node3D *self);

/* NO-TEST */
/* $B%j%J%s%P%j%s%0MQ$K@aE@$r%^!<%/$9$k!#(B */
void AutoMesh_Node3D_markNodeForRenumbering 
(AutoMesh_Node3D *self,
 int nodeId);

/* NO-TEST */
/* $B%j%J%s%P%j%s%0$r9T$&!#(B */
void AutoMesh_Node3D_renumber 
(AutoMesh_Node3D *self);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_Node3D_nNodes 
(AutoMesh_Node3D *self);

/* $B;XDj%l%3!<%I$N:BI8%U%#!<%k%ICM$r5a$a$k!#(B */
void AutoMesh_Node3D_getCoordAt 
(AutoMesh_Node3D *self,
 int nodeId,
 double *x_OUT, double *y_OUT, double *z_OUT);

/* $B@aE@%F!<%V%k$N@j$a$k6u4VNN0hHO0O$r5a$a$k!#(B */
void AutoMesh_Node3D_getRange 
(AutoMesh_Node3D *self,
 double *minX_OUT, double *minY_OUT, double *minZ_OUT,
 double *maxX_OUT, double *maxY_OUT, double *maxZ_OUT);

/* $B;XDj$N(B2$B%l%3!<%I4V$N5wN%$r5a$a$k!#(B */
double AutoMesh_Node3D_distance 
(AutoMesh_Node3D *self,
 int nodeId0, 
 int nodeId1);

/* NO-TEST */
/* $B%j%J%s%P%j%s%0$5$l$?%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_Node3D_renumberedCount
(AutoMesh_Node3D *self);

/* NO-TEST */
/* $B%j%J%s%P%j%s%0$5$l$?$+$I$&$+!#(B */
int AutoMesh_Node3D_isRenumbered 
(AutoMesh_Node3D *self,
 int nodeId);

/* NO-TEST */
/* $B;XDj%l%3!<%I$N%j%J%s%P%j%s%0(BID$B$r5a$a$k!#(B */
int AutoMesh_Node3D_renumberedId 
(AutoMesh_Node3D *self,
 int nodeId);



#endif  /* __AUTOMESH_NODE3D__ */
