/* header file for automesh_node_vector2d.c */

#ifndef __AUTOMESH_NODE_VECTOR2D__
#define __AUTOMESH_NODE_VECTOR2D__



/* NodeVector2D */

/* $B@aE@%Y%/%H%k%/%i%9(B */
typedef struct _AutoMesh_NodeVector2D {
  AutoRes_Handle handle;

  AutoMesh_Node2D *node;
  /* $B@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoRes_Real1DColumn *nodes_value;  /* [2] */
  /* $B%Y%/%H%kCM%+%i%`(B */
} AutoMesh_NodeVector2D;

AUTORES_DECLARE_HANDLE(AutoMesh_NodeVector2D)

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_NodeVector2D *AutoMesh_NodeVector2D_New 
(AutoMesh_Node2D *node);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_NodeVector2D_delete 
(AutoMesh_NodeVector2D *self);

/* $BCM$N%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N@aE@%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_NodeVector2D_makeValueColumn 
(AutoMesh_NodeVector2D *self);

/* $B;XDj@aE@%l%3!<%I$N%Y%/%H%kCM$r@_Dj$9$k!#(B */
void AutoMesh_NodeVector2D_setValueAt 
(AutoMesh_NodeVector2D *self,
 int nodeId,
 double valueX, double valueY);

/* $B;XDj@aE@%l%3!<%I$N%Y%/%H%kCM$r5a$a$k!#(B */
void AutoMesh_NodeVector2D_getValueAt 
(AutoMesh_NodeVector2D *self,
 int nodeId,
 double *valueX_OUT, double *valueY_OUT);

/* $B@aE@%F!<%V%kA4BN$G$N%Y%/%H%kCM$NBg>.HO0O$r5a$a$k!#(B */
void AutoMesh_NodeVector2D_getRange 
(AutoMesh_NodeVector2D *self,
 double *minValueX_OUT, double *minValueY_OUT,
 double *maxValueX_OUT, double *maxValueY_OUT);

/* $B@aE@%F!<%V%kA4BN$G$N%Y%/%H%kCM$N:GBgD9$5$r5a$a$k!#(B */
double AutoMesh_NodeVector2D_maxLength 
(AutoMesh_NodeVector2D *self);



#endif  /* __AUTOMESH_NODE_VECTOR2D__ */
