/* header file for automesh_node_vector3d.c */

#ifndef __AUTOMESH_NODE_VECTOR3D__
#define __AUTOMESH_NODE_VECTOR3D__



/* NodeVector3D */

/* $B@aE@%Y%/%H%k%/%i%9(B */
typedef struct _AutoMesh_NodeVector3D {
  AutoRes_Handle handle;

  AutoMesh_Node3D *node;
  /* $B@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoRes_Real1DColumn *nodes_value;  /* [3] */
  /* $B%Y%/%H%kCM%+%i%`(B */
} AutoMesh_NodeVector3D;

AUTORES_DECLARE_HANDLE(AutoMesh_NodeVector3D)

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_NodeVector3D *AutoMesh_NodeVector3D_New 
(AutoMesh_Node3D *node);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_NodeVector3D_delete 
(AutoMesh_NodeVector3D *self);

/* $BCM$N%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N@aE@%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_NodeVector3D_makeValueColumn 
(AutoMesh_NodeVector3D *self);

/* $B;XDj@aE@%l%3!<%I$N%Y%/%H%kCM$r@_Dj$9$k!#(B */
void AutoMesh_NodeVector3D_setValueAt 
(AutoMesh_NodeVector3D *self,
 int nodeId,
 double valueX, double valueY, double valueZ);

/* $B;XDj@aE@%l%3!<%I$N%Y%/%H%kCM$r5a$a$k!#(B */
void AutoMesh_NodeVector3D_getValueAt 
(AutoMesh_NodeVector3D *self,
 int nodeId,
 double *valueX_OUT, double *valueY_OUT, double *valueZ_OUT);

/* $B@aE@%F!<%V%kA4BN$G$N%Y%/%H%kCM$NBg>.HO0O$r5a$a$k!#(B */
void AutoMesh_NodeVector3D_getRange 
(AutoMesh_NodeVector3D *self,
 double *minValueX_OUT, double *minValueY_OUT, double *minValueZ_OUT,
 double *maxValueX_OUT, double *maxValueY_OUT, double *maxValueZ_OUT);

/* $B@aE@%F!<%V%kA4BN$G$N%Y%/%H%kCM$N:GBgD9$5$r5a$a$k!#(B */
double AutoMesh_NodeVector3D_maxLength 
(AutoMesh_NodeVector3D *self);



#endif  /* __AUTOMESH_NODE_VECTOR3D__ */
