/* header file for automesh_surface_boundary_edge3d.c */

#ifndef __AUTOMESH_SURFACE_BOUNDARY_EDGE3D__
#define __AUTOMESH_SURFACE_BOUNDARY_EDGE3D__



/* SurfaceBoundaryEdge3D */

/* $B%5!<%U%'%9MWAG$N6-3&NG@~%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_SurfaceBoundaryEdge3D {
  AutoRes_Handle handle;

  AutoMesh_PolygonType polygonType;
  /* $BB?3Q7A%?%$%W(B */
  int nElementEdges;
  /* $BMWAG$"$?$j$NJU?t(B */

  AutoMesh_SurfaceElement3D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoRes_Table *edges;  /* OWN */
  /* $B6-3&NG@~%F!<%V%k(B */
  AutoRes_FreeListCollection *edgeCollection;
  /* $B:o=|MQ%U%j!<%j%9%H(B */
  AutoRes_Integer1DColumn *edges_vertexNodeIds;  /* [2], WORK AREA */
  /* 2$BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`(B
     ($BD:E@@aE@;2>H(B) */
  AutoRes_IntegerColumn *edges_elementId;  
  /* $BFbB&$K$"$kMWAG%l%3!<%I(BID$B%+%i%`(B
     ($BFbB&MWAG;2>H(B) */
  AutoRes_IntegerColumn *edges_elementEdgeNum;  
  /* $BFbB&$K$"$kMWAG$NMWAGJUHV9f%+%i%`(B
     ($BFbB&MWAG;2>H(B) */
} AutoMesh_SurfaceBoundaryEdge3D;

AUTORES_DECLARE_HANDLE(AutoMesh_SurfaceBoundaryEdge3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_SurfaceBoundaryEdge3D *AutoMesh_SurfaceBoundaryEdge3D_New 
(AutoMesh_SurfaceElement3D *element);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_SurfaceBoundaryEdge3D_delete 
(AutoMesh_SurfaceBoundaryEdge3D *self);

/* $BD:E@@aE@;2>H(B */
/* 2$BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_SurfaceBoundaryEdge3D_makeVertexNodeIdsColumn 
(AutoMesh_SurfaceBoundaryEdge3D *self);

/* $BFbB&MWAG;2>H(B */
/* $BMWAG%l%3!<%I(BID$B%+%i%`$*$h$SMWAGJUHV9f%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_SurfaceBoundaryEdge3D_makeElementIdColumn 
(AutoMesh_SurfaceBoundaryEdge3D *self);

/* $B6-3&NG@~$rCj=P$9$k!#(B */
int /* boolean */
AutoMesh_SurfaceBoundaryEdge3D_extract 
(AutoMesh_SurfaceBoundaryEdge3D *self);

/* $B:n6HMQ%a%b%jNN0h$rGK4~$9$k!#(B */
/* $BD:E@@aE@%+%i%`$*$h$S%U%j!<%j%9%H$,:o=|$5$l$k!#(B */
void AutoMesh_SurfaceBoundaryEdge3D_purgeWorkArea 
(AutoMesh_SurfaceBoundaryEdge3D *self);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_SurfaceBoundaryEdge3D_nEdges 
(AutoMesh_SurfaceBoundaryEdge3D *self);

/* $BFbB&MWAG;2>H(B */
/* $B;XDj%l%3!<%I$NFbB&MWAG%l%3!<%I(BID$B$*$h$SMWAGJUHV9f$r5a$a$k!#(B */
void AutoMesh_SurfaceBoundaryEdge3D_getEdgeAt 
(AutoMesh_SurfaceBoundaryEdge3D *self,
 int edgeId,
 int *elementId_OUT,
 int *elementEdgeNum_OUT);

/* $BD:E@@aE@;2>H(B */
/* $B;XDj%l%3!<%I$N(B2$BD:E@>e$N@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
void AutoMesh_SurfaceBoundaryEdge3D_getVertexNodeIdsAt 
(AutoMesh_SurfaceBoundaryEdge3D *self,
 int edgeId,
 int *nodeId0_OUT, int *nodeId1_OUT);

/* $B;XDj%l%3!<%I$NCfE@:BI8$r5a$a$k!#(B */
void AutoMesh_SurfaceBoundaryEdge3D_getMidPointAt 
(AutoMesh_SurfaceBoundaryEdge3D *self,
 int edgeId,
 double *x_OUT, double *y_OUT, double *z_OUT);



#endif  /* __AUTOMESH_SURFACE_BOUNDARY_EDGE3D__ */



