/* header file for automesh_surface_edge3d.c */

#ifndef __AUTOMESH_SURFACE_EDGE3D__
#define __AUTOMESH_SURFACE_EDGE3D__



/* SurfaceEdge3D */

/* $B%5!<%U%'%9MWAG$NNG@~%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_SurfaceEdge3D {
  AutoRes_Handle handle;

  AutoMesh_PolygonType polygonType;
  /* $BB?3Q7A%?%$%W(B */
  int nElementEdges;
  /* $BMWAG$"$?$j$NJU?t(B */

  AutoMesh_SurfaceElement3D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_Integer1DColumn *elements_edgeIds;  /* [nElementEdges] */
  /* $BNG@~%l%3!<%I(BID$B%+%i%`(B
     ($BMWAGNG@~;2>H(B) */

  AutoRes_Table *edges;  /* OWN */
  /* $BNG@~%F!<%V%k(B */
  AutoRes_Integer1DColumn *edges_vertexNodeIds; /* [2], WORK AREA */
  /* 2$BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`(B
     ($BD:E@@aE@;2>H(B) */
  AutoRes_Integer1DColumn *edges_elementIds;  /* [2] */
  /* $BN>%5%$%I$K$"$kMWAG%l%3!<%I(BID$B%+%i%`(B
     ($B%5%$%IMWAG;2>H(B) */
  AutoRes_Integer1DColumn *edges_elementEdgeNums;  /* [2] */
  /* $BN>%5%$%I$K$"$kMWAG$NMWAGJUHV9f%+%i%`(B
     ($B%5%$%IMWAG;2>H(B) */
} AutoMesh_SurfaceEdge3D;

/* edges_elementIds[0] is not -1 */
/* edges_elementIds[1] can be -1, if so, it is on boundary */

AUTORES_DECLARE_HANDLE(AutoMesh_SurfaceEdge3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_SurfaceEdge3D *AutoMesh_SurfaceEdge3D_New 
(AutoMesh_SurfaceElement3D *element);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_SurfaceEdge3D_delete 
(AutoMesh_SurfaceEdge3D *self);

/* $BMWAGNG@~;2>H(B */
/* $BMWAG%l%3!<%I$4$H$NNG@~%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$NMWAG%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_SurfaceEdge3D_makeEdgeIdsAtElementColumn 
(AutoMesh_SurfaceEdge3D *self);

/* $BD:E@@aE@;2>H(B */
/* 2$BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_SurfaceEdge3D_makeVertexNodeIdsColumn 
(AutoMesh_SurfaceEdge3D *self);

/* $B%5%$%IMWAG;2>H(B */
/* $BMWAG%l%3!<%I(BID$B%+%i%`$*$h$SMWAGJUHV9f%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_SurfaceEdge3D_makeElementIdsColumn 
(AutoMesh_SurfaceEdge3D *self);

/* $BNG@~$rCj=P$9$k!#(B */
int /* boolean */
AutoMesh_SurfaceEdge3D_extract 
(AutoMesh_SurfaceEdge3D *self,
 int elementIdsFlag);
/* elementIdsFlag : $B%5%$%IMWAG;2>H$r@8@.$9$k$+$I$&$+!#(B */

/* $B:n6HMQ%a%b%jNN0h$rGK4~$9$k!#(B */
/* $BD:E@@aE@%+%i%`$,:o=|$5$l$k!#(B */
void AutoMesh_SurfaceEdge3D_purgeWorkArea 
(AutoMesh_SurfaceEdge3D *self);

/* $BMWAGNY@\4X78$r:n@.$9$k!#(B */
/* $BMWAG%F!<%V%k$KNY@\4X78$r@_Dj$9$k!#(B */
int AutoMesh_SurfaceEdge3D_collectNeighbor 
(AutoMesh_SurfaceEdge3D *self);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_SurfaceEdge3D_nEdges 
(AutoMesh_SurfaceEdge3D *self);

/* $B%5%$%IMWAG;2>H(B */
/* $B;XDj%l%3!<%I$NN>%5%$%I$K$*$1$kMWAG%l%3!<%I(BID$B$*$h$SMWAGJUHV9f$r5a$a$k!#(B */
void AutoMesh_SurfaceEdge3D_getEdgeAt 
(AutoMesh_SurfaceEdge3D *self,
 int edgeId,
 int elementIds_OUT[2],
 int elementEdgeNums_OUT[2]);
/* elementIds_OUT : $BMWAG%l%3!<%I(BID$B$^$?$O(B-1 */

/* $B;XDj%l%3!<%I$,6-3&>e$K$"$k$+$I$&$+!#(B */
int /* boolean */
AutoMesh_SurfaceEdge3D_isOnBoundaryAt 
(AutoMesh_SurfaceEdge3D *self,
 int edgeId);

/* $B%5%$%IMWAG;2>H(B */
/* $B$b$7!";XDj%l%3!<%I$,6-3&>e$K$"$l$P!"(B
   $B$=$NFbB&$K$"$kMWAG%l%3!<%I(BID$B$HMWAGJUHV9f$r5a$a$k!#(B */
int /* boolean */
AutoMesh_SurfaceEdge3D_getBoundaryAt 
(AutoMesh_SurfaceEdge3D *self,
 int edgeId,
 int *elementId_OUT,
 int *elementEdgeNum_OUT);
/* $B6-3&>e$K$"$k$+$I$&$+$rJV$9!#(B */

/* $BD:E@@aE@;2>H(B */
/* $B;XDj%l%3!<%I$N(B2$BD:E@>e$N@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
void AutoMesh_SurfaceEdge3D_getVertexNodeIdsAt 
(AutoMesh_SurfaceEdge3D *self,
 int edgeId,
 int *nodeId0_OUT, int *nodeId1_OUT);

/* $B;XDj%l%3!<%I$NCfE@:BI8$r5a$a$k!#(B */
void AutoMesh_SurfaceEdge3D_getMidPointAt 
(AutoMesh_SurfaceEdge3D *self,
 int edgeId,
 double *x_OUT, double *y_OUT, double *z_OUT);

/* $BMWAGNG@~;2>H(B */
/* $B;XDjMWAG%l%3!<%I!"MWAGJUHV9f$K$*$1$kNG@~%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_SurfaceEdge3D_edgeIdAtElement 
(AutoMesh_SurfaceEdge3D *self,
 int elementId,
 int elementEdgeNum);



#endif  /* __AUTOMESH_SURFACE_EDGE3D__ */



