/* header file for automesh_surface_element3d.c */

#ifndef __AUTOMESH_SURFACE_ELEMENT3D__
#define __AUTOMESH_SURFACE_ELEMENT3D__



/* SurfaceElement3D */

/*
  AutoMesh$B!V$*$?$a$7!W$K$*$1$kMWAG@aE@%3%M%/%F%#%S%F%#(B
  ($BMWAG%3%M%/%F%#%S%F%#%+%i%`$NG[Ns=g=x$K4X$9$k7h$^$j(B)

  $B0l<!@aE@$OD:E@>e$K$"$k@aE@$G$"$k!#(B
  $B$7$?$,$C$F!"3F0l<!@aE@$OD:E@$H0lBN0l$GBP1~$9$k!#(B
  $B$3$N$H$-!"0l<!@aE@$NJB$S$O!"D:E@$NJB$S$HF1$8$K$J$k!#(B
  $B$3$l$i$OMWAG%3%M%/%F%#%S%F%#G[Ns$N:G=i$KG[CV$5$l$k!#(B

  $BFs<!@aE@$OJU>e$NCf4V@aE@$G$"$k!#(B
  $B$3$l$i$OMWAG%3%M%/%F%#%S%F%#G[Ns$K$*$$$F0l<!@aE@$N<!$KG[CV$5$l$k!#(B
  $B$7$?$,$C$F!"3FFs<!MWAG$OJU$H0lBN0l$GBP1~$9$k!#(B
  $B$3$N$H$-!"Fs<!@aE@$NJB$S$O!"JU$NJB$S$HF1$8$K$J$k!#(B

  $B$=$l0J>e$N9b<!@aE@$O0lHL$KJU>e$dMWAGFbIt$K$"$j!"(B
  $B$3$l$i$OMWAG%3%M%/%F%#%S%F%#G[Ns$K$*$$$F0l<!MWAG$N8e$KG[CV$5$l$k!#(B
 */

/* $B%5!<%U%'%9MWAG%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_SurfaceElement3D {
  AutoRes_Handle handle;

  AutoMesh_PolygonType polygonType;
  /* $BB?3Q7A%?%$%W(B */
  int nElementNodes;
  /* $BMWAG$"$?$j$N@aE@?t(B */
  int nElementVertexs;
  /* $BMWAG$"$?$j$ND:E@?t(B */
  int nElementEdges;
  /* $BMWAG$"$?$j$NJU?t(B */
  AutoMesh_Node3D *node;
  /* $B@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoRes_Table *elements;  /* OWN */
  /* $BMWAG%F!<%V%k(B */
  AutoRes_Integer1DColumn *elements_nodeIds;  /* [nElementNodes] */
  /* $B@aE@%l%3!<%I(BID$B%+%i%`(B
     ($BMWAG%3%M%/%F%#%S%F%#(B) */
  AutoRes_Integer1DColumn *elements_neighborIds;  /* [nElementEdges] */
  /* $BNY@\MWAG%l%3!<%I(BID$B%+%i%`(B
     ($BNY@\MWAG4X78(B) */
} AutoMesh_SurfaceElement3D;

AUTORES_DECLARE_HANDLE(AutoMesh_SurfaceElement3D)

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_SurfaceElement3D *AutoMesh_SurfaceElement3D_New 
(AutoMesh_Node3D *node,
 AutoMesh_PolygonType polygonType,
 int nElementNodes);
/* polygonType : $BB?3Q7A%?%$%W(B */
/* nElementNodes : $BMWAG$"$?$j$N@aE@?t(B */

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_SurfaceElement3D_delete 
(AutoMesh_SurfaceElement3D *self);

/* $B;XDj$N%l%3!<%I?t$r@_Dj$9$k!#(B*/
/* $B$=$NJ,$N%l%3!<%I$,$^$H$a$F@8@.$5$l$k!#(B */
/* $B$3$l$^$G$K@8@.$5$l$?%+%i%`J,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */ 
AutoMesh_SurfaceElement3D_allocateElements 
(AutoMesh_SurfaceElement3D *self,
 int nElements);

/* $B;XDj?t$N%l%3!<%I$rM=Ls$9$k!#(B */
/* $B$?$@$7!"%l%3!<%I?t<+BN$O(B0$B$N$^$^!#(B */
/* $B$3$l$^$G$K@8@.$5$l$?%+%i%`J,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */ 
AutoMesh_SurfaceElement3D_reserveElements 
(AutoMesh_SurfaceElement3D *self,
 int nElements);

/* $B%l%3!<%I$r0l$D?75,$KDI2C$9$k!#(B */
/* $B$3$l$K$h$j!"%l%3!<%I?t$O(B1$B$DA}$($k!#(B */
int AutoMesh_SurfaceElement3D_addElement 
(AutoMesh_SurfaceElement3D *self);
/* $B%l%3!<%I(BID$B$rJV$9!#(B($B<:GT$J$i(B-1) */

/* $B@aE@%3%M%/%F%#%S%F%#(B */
/* $B@aE@%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_SurfaceElement3D_makeNodeIdsColumn 
(AutoMesh_SurfaceElement3D *self);

/* $B@aE@%3%M%/%F%#%S%F%#(B */
/* $B;XDj%l%3!<%I!"@aE@HV9f$N@aE@%l%3!<%I(BID$B$r@_Dj$9$k!#(B */
void AutoMesh_SurfaceElement3D_setNodeIdAt 
(AutoMesh_SurfaceElement3D *self,
 int elementId,
 int elementNodeNum,
 int nodeId);

/* $BNY@\MWAG4X78(B */
/* $BNY@\MWAG%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_SurfaceElement3D_makeNeighborIdsColumn 
(AutoMesh_SurfaceElement3D *self);

/* $BNY@\MWAG4X78(B */
/* $B;XDj%l%3!<%I!"JUHV9f$GNY@\$9$kMWAG%l%3!<%I(BID$B$r@_Dj$9$k!#(B */
void AutoMesh_SurfaceElement3D_setNeighborIdAt 
(AutoMesh_SurfaceElement3D *self,
 int elementId,
 int elementEdgeNum,
 int neighborId);

/* NO-TEST */
/* $B;XDj%l%3!<%I$K$D$$$F%j%J%s%P%j%s%0MQ$K@aE@$r%^!<%/$9$k!#(B */
void AutoMesh_SurfaceElement3D_markElementForNodeRenumbering 
(AutoMesh_SurfaceElement3D *self,
 int elementId);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_SurfaceElement3D_nElements 
(AutoMesh_SurfaceElement3D *self);

/* $B@aE@%3%M%/%F%#%S%F%#(B */
/* $B;XDj%l%3!<%I!"@aE@HV9f$N@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_SurfaceElement3D_nodeIdAt 
(AutoMesh_SurfaceElement3D *self,
 int elementId,
 int elementNodeNum);

/* $BNY@\MWAG4X78(B */
/* $B;XDj%l%3!<%I!"JUHV9f$GNY@\$9$kMWAG%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_SurfaceElement3D_neighborIdAt 
(AutoMesh_SurfaceElement3D *self,
 int elementId,
 int elementEdgeNum);

/* $B;XDj%l%3!<%I$,@j$a$k6u4VNN0hHO0O$r5a$a$k!#(B */
void AutoMesh_SurfaceElement3D_getRangeAt
(AutoMesh_SurfaceElement3D *self,
 int elementId, 
 double *minRangeX_OUT, double *minRangeY_OUT, double *minRangeZ_OUT,
 double *maxRangeX_OUT, double *maxRangeY_OUT, double *maxRangeZ_OUT);

/* $B;XDj%l%3!<%I$NJ?6QNG@~D9$5(B($BMWAG%5%$%:(B)$B$r5a$a$k!#(B */
double AutoMesh_SurfaceElement3D_averageEdgeLengthAt
(AutoMesh_SurfaceElement3D *self,
 int elementId);

/* $B;XDj%l%3!<%I$NK!@~J}8~%Y%/%H%k$r5a$a$k!#(B */
void AutoMesh_SurfaceElement3D_getNormalAt 
(AutoMesh_SurfaceElement3D *self,
 int elementId,
 double *nx_OUT, double *ny_OUT, double *nz_OUT);



#endif  /* __AUTOMESH_SURFACE_ELEMENT3D__ */



