/* header file for automesh_surface_grouper3d.c */

#ifndef __AUTOMESH_SURFACE_GROUPER3D__
#define __AUTOMESH_SURFACE_GROUPER3D__



/* SurfaceGrouper3D */

/* $BMWAG$r%0%k!<%W2=$9$k%/%i%9(B */
typedef struct _AutoMesh_SurfaceGrouper3D {
  AutoRes_Handle handle;

  int nGroups;
  /* $B@8@.$5$l$?%0%k!<%W?t(B */
  
  int nFrameGroups;
  /* $B@8@.$5$l$?%U%l!<%`%0%k!<%W?t(B */
  
  int nFrameVertexs;
  /* $B@8@.$5$l$?%U%l!<%`D:E@?t(B */
  
  AutoMesh_Node3D *node;
  /* $B@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *nodes_frameVertexId;
  /* $B%U%l!<%`D:E@HV9f%+%i%`(B */
  AutoRes_IntegerColumn *nodes_markFlag;  /* WORK AREA */

  AutoMesh_SurfaceElement3D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *elements_groupId;
  /* $B%0%k!<%WHV9f%+%i%`(B */
  AutoRes_IntegerColumn *elements_elementId;  /* WORK AREA */
  AutoRes_IntegerColumn *elements_elementEdgeNum;  /* WORK AREA */

  AutoMesh_SurfaceEdge3D *edge;
  /* $BNG@~%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *edges_frameFlag;
  /* $B%U%l!<%`$+$I$&$+$N%+%i%`(B */
  AutoRes_IntegerColumn *edges_frameGroupId;
  /* $B%U%l!<%`%0%k!<%WHV9f%+%i%`(B */

  AutoMesh_Frame3D *frame;  /* CREATE */
  /* $B%U%l!<%`%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
} AutoMesh_SurfaceGrouper3D;

AUTORES_DECLARE_HANDLE(AutoMesh_SurfaceGrouper3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_SurfaceGrouper3D *AutoMesh_SurfaceGrouper3D_New 
(AutoMesh_SurfaceEdge3D *edge);
/* $B6u$N(B<frame>$B$,@8@.$5$l$k!#(B*/

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B(Edge$B$J$7(B) */
AutoMesh_SurfaceGrouper3D *AutoMesh_SurfaceGrouper3D_NewWithoutEdge 
(AutoMesh_SurfaceElement3D *element);
/* <frame>$B$O@8@.$5$l$J$$!#(B*/

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_SurfaceGrouper3D_delete 
(AutoMesh_SurfaceGrouper3D *self);
/* <frame>$B$OGK4~$5$l$J$$$N$GCm0U!#(B*/

/* $BMWAG%l%3!<%I$4$H$N%0%k!<%WHV9f%+%i%`$r@8@.$9$k!#(B */
int /* boolean */
AutoMesh_SurfaceGrouper3D_makeGroupIdAtElementColumn 
(AutoMesh_SurfaceGrouper3D *self);

/* $B%0%k!<%W?t$r@_Dj$9$k!#(B */
void AutoMesh_SurfaceGrouper3D_setNGroups 
(AutoMesh_SurfaceGrouper3D *self);

/* $BNG@~%l%3!<%I$4$H$N%U%l!<%`%U%i%0%+%i%`$r@8@.$9$k!#(B */
int /* boolean */
AutoMesh_SurfaceGrouper3D_makeFrameFlagAtEdgeColumn 
(AutoMesh_SurfaceGrouper3D *self);

/* $BNG@~%l%3!<%I$4$H$N%U%l!<%`%0%k!<%WHV9f%+%i%`$r@8@.$9$k!#(B */
int /* boolean */
AutoMesh_SurfaceGrouper3D_makeFrameGroupIdAtEdgeColumn 
(AutoMesh_SurfaceGrouper3D *self);

/* $B%U%l!<%`%0%k!<%W?t$r@_Dj$9$k!#(B */
void AutoMesh_SurfaceGrouper3D_setNFrameGroups 
(AutoMesh_SurfaceGrouper3D *self);

/* $B@aE@%l%3!<%I$4$H$N%U%l!<%`D:E@HV9f%+%i%`$r@8@.$9$k!#(B */
int /* boolean */
AutoMesh_SurfaceGrouper3D_makeFrameVertexIdAtNodeColumn 
(AutoMesh_SurfaceGrouper3D *self);

/* $B%U%l!<%`D:E@?t$r@_Dj$9$k!#(B */
void AutoMesh_SurfaceGrouper3D_setNFrameVertexs 
(AutoMesh_SurfaceGrouper3D *self);

/* $B:n6H$r9T$&!#(B */
int /* boolean */
AutoMesh_SurfaceGrouper3D_do 
(AutoMesh_SurfaceGrouper3D *self,
 double angle,
 int groupIdFlag,
 int frameFlag,
 int frameGroupIdFlag,
 int frameVertexIdFlag);
/* angle : $BFsLL643Q(B */
/* groupIdFlag : $B%0%k!<%WHV9f%+%i%`$r@8@.$9$k$+$I$&$+!#(B */
/* frameFlag : $B%U%l!<%`%U%i%0%+%i%`$r@8@.$9$k$+$I$&$+!#(B */
/* frameGroupIdFlag : $B%U%l!<%`%0%k!<%WHV9f%+%i%`$r@8@.$9$k$+$I$&$+!#(B */
/* frameVertexIdFlag : $B%U%l!<%`D:E@HV9f%+%i%`$r@8@.$9$k$+$I$&$+!#(B */

/* NO-TEST */
/* $B@aE@A*BrMQ%+%i%`$r@8@.$9$k!#(B */
int /* boolean */
AutoMesh_SurfaceGrouper3D_makeMarkFlagAtNodeColumn 
(AutoMesh_SurfaceGrouper3D *self);

/* NO-TEST */
/* $B%0%k!<%W%;%l%/%7%g%s$KBP1~$9$k@aE@%;%l%/%7%g%s$r5a$a$k!#(B */
AutoRes_Selection *   /* CREATE */ 
AutoMesh_SurfaceGrouper3D_getGroupNode 
(AutoMesh_SurfaceGrouper3D *self,
 AutoRes_Selection *groupSelection);
/* $B?75,$K@8@.$5$l$?%;%l%/%7%g%s$rJV$9!#(B*/

/* NO-TEST */
/* $B%0%k!<%W%;%l%/%7%g%s$KBP1~$9$kMWAG%;%l%/%7%g%s$r5a$a$k!#(B */
AutoRes_Selection *   /* CREATE */ 
AutoMesh_SurfaceGrouper3D_getGroupElement 
(AutoMesh_SurfaceGrouper3D *self,
 AutoRes_Selection *groupSelection);
/* $B?75,$K@8@.$5$l$?%;%l%/%7%g%s$rJV$9!#(B*/

/* $B:n6HMQ%a%b%jNN0h$rGK4~$9$k!#(B */
void AutoMesh_SurfaceGrouper3D_purgeWorkArea 
(AutoMesh_SurfaceGrouper3D *self);

/* $B%0%k!<%W?t$r5a$a$k!#(B */
int AutoMesh_SurfaceGrouper3D_nGroups 
(AutoMesh_SurfaceGrouper3D *self);

/* $B;XDjMWAG%l%3!<%I$N%0%k!<%WHV9f$r5a$a$k!#(B */
int AutoMesh_SurfaceGrouper3D_groupIdAtElement 
(AutoMesh_SurfaceGrouper3D *self,
 int elementId);

/* $B;XDjNG@~%l%3!<%I$K$D$$$F%U%l!<%`$+$I$&$+!#(B */
int /* boolean */
AutoMesh_SurfaceGrouper3D_frameFlagAtEdge 
(AutoMesh_SurfaceGrouper3D *self,
 int edgeId);

/* $B%U%l!<%`%0%k!<%W?t$r5a$a$k!#(B */
int AutoMesh_SurfaceGrouper3D_nFrameGroups 
(AutoMesh_SurfaceGrouper3D *self);

/* $B;XDjNG@~%l%3!<%I$N%U%l!<%`%0%k!<%WHV9f$r5a$a$k!#(B */
int AutoMesh_SurfaceGrouper3D_frameGroupIdAtEdge 
(AutoMesh_SurfaceGrouper3D *self,
 int edgeId);

/* $B%U%l!<%`D:E@?t$r5a$a$k!#(B */
int AutoMesh_SurfaceGrouper3D_nFrameVertexs 
(AutoMesh_SurfaceGrouper3D *self);

/* $B;XDj@aE@%l%3!<%I$N%U%l!<%`D:E@HV9f$r5a$a$k!#(B */
int AutoMesh_SurfaceGrouper3D_frameVertexIdAtNode 
(AutoMesh_SurfaceGrouper3D *self,
 int nodeId);



#endif  /* __AUTOMESH_SURFACE_GROUPER3D__ */



