/* header file for automesh_surface_mid_node_remover3d.c */

#ifndef __AUTOMESH_SURFACE_MID_NODE_REMOVER3D__
#define __AUTOMESH_SURFACE_MID_NODE_REMOVER3D__



/* SurfaceMidNodeRemover3D */

/* $BCf4V@aE@$r:o=|$7!"Fs<!MWAG%a%C%7%e$+$i0l<!MWAG%a%C%7%e$r@8@.$9$k%/%i%9(B */
typedef struct _AutoMesh_SurfaceMidNodeRemover3D {
  AutoRes_Handle handle;

  AutoMesh_Node3D* srcNode;
  /* $B9b<!B&@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *srcNodes_destNodeId;
  /* $BDc<!B&@aE@%l%3!<%I(BID$B%+%i%`(B
     ($B9b<!B&@aE@$+$iDc<!B&@aE@$X$N;2>H(B) */
  
  AutoMesh_SurfaceElement3D* srcElement;
  /* $B9b<!B&MWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoMesh_Node3D *destNode;  /* CREATE */
  /* $BDc<!B&@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *destNodes_srcNodeId;
  /* $B9b<!B&@aE@%l%3!<%I(BID$B%+%i%`(B
     ($BDc<!B&@aE@$+$i9b<!B&@aE@$X$N;2>H(B) */

  AutoMesh_SurfaceElement3D* destElement;  /* CREATE */
  /* $BDc<!B&MWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
} AutoMesh_SurfaceMidNodeRemover3D;

AUTORES_DECLARE_HANDLE(AutoMesh_SurfaceMidNodeRemover3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_SurfaceMidNodeRemover3D *AutoMesh_SurfaceMidNodeRemover3D_New 
(AutoMesh_SurfaceElement3D *element);
/* $B6u$N(B<destNode>, <destElement>$B$,$=$l$>$l@8@.$5$l$k!#(B*/

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_SurfaceMidNodeRemover3D_delete 
(AutoMesh_SurfaceMidNodeRemover3D *self);
/* <destNode>, <destElement>$B$OGK4~$5$l$J$$$N$GCm0U!#(B*/

/* $B:n6H$r9T$&!#(B */
int /* boolean */
AutoMesh_SurfaceMidNodeRemover3D_do 
(AutoMesh_SurfaceMidNodeRemover3D *self,
 int nodeFlag,
 int elementFlag,
 int srcNodeIdFlag);
/* nodeFlag : $B@aE@:BI8$r@8@.$9$k$+$I$&$+!#(B */
/* elementFlag : $BMWAG%3%M%/%F%#%S%F%#$r@8@.$9$k$+$I$&$+!#(B */
/* srcNodeIdsFlag : 
   $BDc<!B&@aE@$+$i9b<!B&@aE@$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */

/* $B9b<!B&@aE@$+$iDc<!B&@aE@$X$N;2>H(B */
/* $B;XDj$N9b<!B&@aE@%l%3!<%I$K$*$1$kDc<!B&@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_SurfaceMidNodeRemover3D_destNodeIdAtSrcNode
(AutoMesh_SurfaceMidNodeRemover3D *self,
 int srcNodeId);

/* $BDc<!B&@aE@$+$i9b<!B&@aE@$X$N;2>H(B */
/* $B;XDj$NDc<!B&@aE@%l%3!<%I$K$*$1$k9b<!B&@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_SurfaceMidNodeRemover3D_srcNodeIdAtDestNode
(AutoMesh_SurfaceMidNodeRemover3D *self,
 int destNodeId);



#endif  /* __AUTOMESH_SURFACE_MID_NODE_REMOVER3D__ */
