/* header file for automesh_volume_boundary_edge2d.c */

#ifndef __AUTOMESH_VOLUME_BOUNDARY_EDGE2D__
#define __AUTOMESH_VOLUME_BOUNDARY_EDGE2D__



/* VolumeBoundaryEdge2D */

/* $B%\%j%e!<%`MWAG$N6-3&NG@~%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_VolumeBoundaryEdge2D {
  AutoRes_Handle handle;

  AutoMesh_PolygonType polygonType;
  /* $BB?3Q7A%?%$%W(B */
  int nElementEdges;
  /* $BMWAG$"$?$j$NJU?t(B */

  AutoMesh_VolumeElement2D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoRes_Table *edges;  /* OWN */
  /* $B6-3&NG@~%F!<%V%k(B */
  AutoRes_FreeListCollection *edgeCollection;
  /* $B:o=|MQ%U%j!<%j%9%H(B */
  AutoRes_Integer1DColumn *edges_vertexNodeIds;  /* [2], WORK AREA */
  /* 2$BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`(B
     ($BD:E@@aE@;2>H(B) */
  AutoRes_IntegerColumn *edges_elementId;  
  /* $BFbB&$K$"$kMWAG%l%3!<%I(BID$B%+%i%`(B
     ($BFbB&MWAG;2>H(B) */
  AutoRes_IntegerColumn *edges_elementEdgeNum;  
  /* $BFbB&$K$"$kMWAG$NMWAGJUHV9f%+%i%`(B
     ($BFbB&MWAG;2>H(B) */
} AutoMesh_VolumeBoundaryEdge2D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeBoundaryEdge2D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeBoundaryEdge2D *AutoMesh_VolumeBoundaryEdge2D_New 
(AutoMesh_VolumeElement2D *element);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeBoundaryEdge2D_delete 
(AutoMesh_VolumeBoundaryEdge2D *self);

/* $BD:E@@aE@;2>H(B */
/* 2$BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_VolumeBoundaryEdge2D_makeVertexNodeIdsColumn 
(AutoMesh_VolumeBoundaryEdge2D *self);

/* $BFbB&MWAG;2>H(B */
/* $BMWAG%l%3!<%I(BID$B%+%i%`$*$h$SMWAGJUHV9f%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_VolumeBoundaryEdge2D_makeElementIdColumn 
(AutoMesh_VolumeBoundaryEdge2D *self);

/* $B6-3&NG@~$rCj=P$9$k!#(B */
int /* boolean */
AutoMesh_VolumeBoundaryEdge2D_extract 
(AutoMesh_VolumeBoundaryEdge2D *self);

/* $B:n6HMQ%a%b%jNN0h$rGK4~$9$k!#(B */
/* $BD:E@@aE@%+%i%`$*$h$S%U%j!<%j%9%H$,:o=|$5$l$k!#(B */
void AutoMesh_VolumeBoundaryEdge2D_purgeWorkArea 
(AutoMesh_VolumeBoundaryEdge2D *self);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_VolumeBoundaryEdge2D_nEdges 
(AutoMesh_VolumeBoundaryEdge2D *self);

/* $BFbB&MWAG;2>H(B */
/* $B;XDj%l%3!<%I$NFbB&MWAG%l%3!<%I(BID$B$*$h$SMWAGJUHV9f$r5a$a$k!#(B */
void AutoMesh_VolumeBoundaryEdge2D_getEdgeAt 
(AutoMesh_VolumeBoundaryEdge2D *self,
 int edgeId,
 int *elementId_OUT,
 int *elementEdgeNum_OUT);

/* $BD:E@@aE@;2>H(B */
/* $B;XDj%l%3!<%I$N(B2$BD:E@>e$N@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
void AutoMesh_VolumeBoundaryEdge2D_getVertexNodeIdsAt 
(AutoMesh_VolumeBoundaryEdge2D *self,
 int edgeId,
 int *nodeId0_OUT, int *nodeId1_OUT);

/* $B;XDj%l%3!<%I$NCfE@:BI8$r5a$a$k!#(B */
void AutoMesh_VolumeBoundaryEdge2D_getMidPointAt 
(AutoMesh_VolumeBoundaryEdge2D *self,
 int edgeId,
 double *x_OUT, double *y_OUT);



#endif  /* __AUTOMESH_VOLUME_BOUNDARY_EDGE2D__ */



