/* header file for automesh_volume_boundary_face3d.c */

#ifndef __AUTOMESH_VOLUME_BOUNDARY_FACE3D__
#define __AUTOMESH_VOLUME_BOUNDARY_FACE3D__



/* VolumeBoundaryFace3D */

/* $B%\%j%e!<%`MWAG$N6-3&I=LL%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_VolumeBoundaryFace3D {
  AutoRes_Handle handle;

  AutoMesh_PolyhedronType polyhedronType;
  /* $BB?LLBN%?%$%W(B */
  int nElementFaces;
  /* $BMWAG$"$?$j$NLL?t(B */

  AutoMesh_VolumeElement3D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoRes_Table *faces;  /* OWN */
  /* $B6-3&I=LL%F!<%V%k(B */
  AutoRes_FreeListCollection *faceCollection;
  /* $B:o=|MQ%U%j!<%j%9%H(B */
  AutoRes_Integer1DColumn *faces_vertexNodeIds;  /* [nFaceVertexs], WORK AREA */
  /* $BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`(B
     ($BD:E@@aE@;2>H(B) */
  AutoRes_IntegerColumn *faces_elementId;  
  /* $BFbB&$K$"$kMWAG%l%3!<%I(BID$B%+%i%`(B
     ($BFbB&MWAG;2>H(B) */
  AutoRes_IntegerColumn *faces_elementFaceNum;  
  /* $BFbB&$K$"$kMWAG$NMWAGLLHV9f%+%i%`(B
     ($BFbB&MWAG;2>H(B) */
} AutoMesh_VolumeBoundaryFace3D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeBoundaryFace3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeBoundaryFace3D *AutoMesh_VolumeBoundaryFace3D_New 
(AutoMesh_VolumeElement3D *element);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeBoundaryFace3D_delete 
(AutoMesh_VolumeBoundaryFace3D *self);

/* $BD:E@@aE@;2>H(B */
/* $BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_VolumeBoundaryFace3D_makeVertexNodeIdsColumn 
(AutoMesh_VolumeBoundaryFace3D *self,
 int nFaceVertexs);

/* $BFbB&MWAG;2>H(B */
/* $BMWAG%l%3!<%I(BID$B%+%i%`$*$h$SMWAGLLHV9f%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_VolumeBoundaryFace3D_makeElementIdColumn 
(AutoMesh_VolumeBoundaryFace3D *self);

/* $B6-3&I=LL$rCj=P$9$k!#(B */
int /* boolean */
AutoMesh_VolumeBoundaryFace3D_extract 
(AutoMesh_VolumeBoundaryFace3D *self);

/* $B:n6HMQ%a%b%jNN0h$rGK4~$9$k!#(B */
/* $BD:E@@aE@%+%i%`$*$h$S%U%j!<%j%9%H$,:o=|$5$l$k!#(B */
void AutoMesh_VolumeBoundaryFace3D_purgeWorkArea 
(AutoMesh_VolumeBoundaryFace3D *self);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_VolumeBoundaryFace3D_nFaces 
(AutoMesh_VolumeBoundaryFace3D *self);

/* $BFbB&MWAG;2>H(B */
/* $B;XDj%l%3!<%I$NFbB&MWAG%l%3!<%I(BID$B$*$h$SMWAGLLHV9f$r5a$a$k!#(B */
void AutoMesh_VolumeBoundaryFace3D_getFaceAt 
(AutoMesh_VolumeBoundaryFace3D *self,
 int faceId,
 int *elementId_OUT,
 int *elementFaceNum_OUT);



#endif  /* __AUTOMESH_VOLUME_BOUNDARY_FACE3D__ */



