/* header file for automesh_volume_boundary_maker3d.c */

#ifndef __AUTOMESH_VOLUME_BOUNDARY_MAKER3D__
#define __AUTOMESH_VOLUME_BOUNDARY_MAKER3D__



/* VolumeBoundaryMaker3D */

/* $BI=LL$+$i6-3&I=LL>e%5!<%U%'%9$r@8@.$9$k%/%i%9(B */
typedef struct _AutoMesh_VolumeBoundaryMaker3D {
  AutoRes_Handle handle;

  AutoMesh_VolumeFace3D *face;
  /* $B%\%j%e!<%`I=LL%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoMesh_Node3D* volumeNode;
  /* $B%\%j%e!<%`@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *volumeNodes_surfaceNodeId;
  /* $B%5!<%U%'%9@aE@%l%3!<%I(BID$B%+%i%`(B
     ($B%\%j%e!<%`@aE@$+$i%5!<%U%'%9@aE@$X$N;2>H(B) */

  AutoMesh_VolumeElement3D* volumeElement;
  /* $B%\%j%e!<%`MWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  
  AutoMesh_Node3D *surfaceNode;  /* CREATE */
  /* $B%5!<%U%'%9@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *surfaceNodes_volumeNodeId;
  /* $B%\%j%e!<%`@aE@%l%3!<%I(BID$B%+%i%`(B
     ($B%5!<%U%'%9@aE@$+$i%\%j%e!<%`@aE@$X$N;2>H(B) */

  AutoMesh_SurfaceElement3D* surfaceElement;  /* CREATE */
  /* $B%5!<%U%'%9MWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *surfaceElements_volumeFaceId;
  /* $B%\%j%e!<%`I=LL%l%3!<%I(BID$B%+%i%`(B
     ($B%5!<%U%'%9MWAG$+$i%\%j%e!<%`I=LL$X$N;2>H(B) */
  AutoRes_IntegerColumn *surfaceElements_volumeElementId;
  /* $B%\%j%e!<%`MWAG%l%3!<%I(BID$B%+%i%`(B
     ($B%5!<%U%'%9MWAG$+$i%\%j%e!<%`MWAG$X$N;2>H(B) */
  AutoRes_IntegerColumn *surfaceElements_volumeElementFaceId;
  /* $B%\%j%e!<%`MWAG$NMWAGLLHV9f%+%i%`(B
     ($B%5!<%U%'%9MWAG$+$i%\%j%e!<%`MWAG$X$N;2>H(B) */
} AutoMesh_VolumeBoundaryMaker3D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeBoundaryMaker3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeBoundaryMaker3D *AutoMesh_VolumeBoundaryMaker3D_New 
(AutoMesh_VolumeFace3D *face);
/* $B6u$N(B<surfaceNode>, <surfaceElement>$B$,$=$l$>$l@8@.$5$l$k!#(B*/

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeBoundaryMaker3D_delete 
(AutoMesh_VolumeBoundaryMaker3D *self);
/* <surfaceNode>, <surfaceElement>$B$OGK4~$5$l$J$$$N$GCm0U!#(B*/

/* $B:n6H$r9T$&!#(B */
int /* boolean */
AutoMesh_VolumeBoundaryMaker3D_do 
(AutoMesh_VolumeBoundaryMaker3D *self,
 int nodeFlag,
 int elementFlag,
 int volumeNodeIdFlag,
 int volumeElementIdFlag);
/* nodeFlag : $B@aE@:BI8$r@8@.$9$k$+$I$&$+!#(B */
/* elementFlag : $BMWAG%3%M%/%F%#%S%F%#$r@8@.$9$k$+$I$&$+!#(B */
/* volumeNodeIdFlag : 
   $B%5!<%U%'%9@aE@$+$i%\%j%e!<%`@aE@$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */
/* volumeElementIdFlag : 
   $B%5!<%U%'%9MWAG$+$i%\%j%e!<%`MWAG$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */

/* $B%\%j%e!<%`@aE@$+$i%5!<%U%'%9@aE@$X$N;2>H(B */
/* $B;XDj$N%\%j%e!<%`@aE@%l%3!<%I$K$*$1$k%5!<%U%'%9@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeBoundaryMaker3D_surfaceNodeIdAtVolumeNode
(AutoMesh_VolumeBoundaryMaker3D *self,
 int volumeNodeId);

/* $B%5!<%U%'%9@aE@$+$i%\%j%e!<%`@aE@$X$N;2>H(B */
/* $B;XDj$N%5!<%U%'%9@aE@%l%3!<%I$K$*$1$k%\%j%e!<%`@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeBoundaryMaker3D_volumeNodeIdAtSurfaceNode
(AutoMesh_VolumeBoundaryMaker3D *self,
 int surfaceNodeId);

/* $B%5!<%U%'%9MWAG$+$i%\%j%e!<%`I=LL$X$N;2>H(B */
/* $B;XDj$N%5!<%U%'%9MWAG%l%3!<%I$K$*$1$k%\%j%e!<%`I=LL%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeBoundaryMaker3D_volumeFaceIdAtSurfaceElement
(AutoMesh_VolumeBoundaryMaker3D *self,
 int surfaceElementId);

/* $B%5!<%U%'%9MWAG$+$i%\%j%e!<%`MWAG$X$N;2>H(B */
/* $B;XDj$N%5!<%U%'%9MWAG%l%3!<%I$K$*$1$k%\%j%e!<%`MWAG%l%3!<%I(BID$B$r5a$a$k!#(B */
void AutoMesh_VolumeBoundaryMaker3D_getVolumeElementAtSurfaceElement
(AutoMesh_VolumeBoundaryMaker3D *self,
 int surfaceElementId,
 int *volumeElementId_OUT,
 int *volumeElementFaceId_OUT);
/* volumeElementId_OUT : $BMWAG%l%3!<%I(BID */
/* volumeElementFaceId_OUT : $BMWAGLLHV9f(B */



#endif  /* __AUTOMESH_VOLUME_BOUNDARY_MAKER3D__ */



