/* header file for automesh_boundary_maker3d2.c */

#ifndef __AUTOMESH_VOLUME_BOUNDARY_MAKER3D2__
#define __AUTOMESH_VOLUME_BOUNDARY_MAKER3D2__



/* VolumeBoundaryMaker3D2 */

/* $B6-3&I=LL$+$i6-3&I=LL>e%5!<%U%'%9$r@8@.$9$k%/%i%9(B */
typedef struct _AutoMesh_VolumeBoundaryMaker3D2 {
  AutoRes_Handle handle;

  AutoMesh_VolumeBoundaryFace3D *face;
  /* $B%\%j%e!<%`6-3&I=LL%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoMesh_Node3D* volumeNode;
  /* $B%\%j%e!<%`@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *volumeNodes_surfaceNodeId;
  /* $B%5!<%U%'%9@aE@%l%3!<%I(BID$B%+%i%`(B
     ($B%\%j%e!<%`@aE@$+$i%5!<%U%'%9@aE@$X$N;2>H(B) */

  AutoMesh_VolumeElement3D* volumeElement;
  /* $B%\%j%e!<%`MWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  
  AutoMesh_Node3D *surfaceNode;  /* CREATE */
  /* $B%5!<%U%'%9@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *surfaceNodes_volumeNodeId;
  /* $B%\%j%e!<%`@aE@%l%3!<%I(BID$B%+%i%`(B
     ($B%5!<%U%'%9@aE@$+$i%\%j%e!<%`@aE@$X$N;2>H(B) */

  AutoMesh_SurfaceElement3D* surfaceElement;  /* CREATE */
  /* $B%5!<%U%'%9MWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
} AutoMesh_VolumeBoundaryMaker3D2;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeBoundaryMaker3D2);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeBoundaryMaker3D2 *AutoMesh_VolumeBoundaryMaker3D2_New 
(AutoMesh_VolumeBoundaryFace3D *face);
/* $B6u$N(B<surfaceNode>, <surfaceElement>$B$,$=$l$>$l@8@.$5$l$k!#(B*/

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeBoundaryMaker3D2_delete 
(AutoMesh_VolumeBoundaryMaker3D2 *self);
/* <surfaceNode>, <surfaceElement>$B$OGK4~$5$l$J$$$N$GCm0U!#(B*/

/* $B:n6H$r9T$&!#(B */
int /* boolean */
AutoMesh_VolumeBoundaryMaker3D2_do 
(AutoMesh_VolumeBoundaryMaker3D2 *self,
 int nodeFlag,
 int elementFlag,
 int volumeNodeIdFlag);
/* nodeFlag : $B@aE@:BI8$r@8@.$9$k$+$I$&$+!#(B */
/* elementFlag : $BMWAG%3%M%/%F%#%S%F%#$r@8@.$9$k$+$I$&$+!#(B */
/* volumeNodeIdFlag : 
   $B%5!<%U%'%9@aE@$+$i%\%j%e!<%`@aE@$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */

/* $B%\%j%e!<%`@aE@$+$i%5!<%U%'%9@aE@$X$N;2>H(B */
/* $B;XDj$N%\%j%e!<%`@aE@%l%3!<%I$K$*$1$k%5!<%U%'%9@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeBoundaryMaker3D2_surfaceNodeIdAtVolumeNode
(AutoMesh_VolumeBoundaryMaker3D2 *self,
 int volumeNodeId);

/* $B%5!<%U%'%9@aE@$+$i%\%j%e!<%`@aE@$X$N;2>H(B */
/* $B;XDj$N%5!<%U%'%9@aE@%l%3!<%I$K$*$1$k%\%j%e!<%`@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeBoundaryMaker3D2_volumeNodeIdAtSurfaceNode
(AutoMesh_VolumeBoundaryMaker3D2 *self,
 int surfaceNodeId);



#endif  /* __AUTOMESH_VOLUME_BOUNDARY_MAKER3D2__ */



