/* header file for automesh_volume_divider3d.c */

#ifndef __AUTOMESH_VOLUME_DIVIDER3D__
#define __AUTOMESH_VOLUME_DIVIDER3D__



/* VolumeDivider3D */

/* $B%a%C%7%e$r6QEy:YJ,3d$9$k%/%i%9(B */
typedef struct _AutoMesh_VolumeDivider3D {
  AutoRes_Handle handle;

  AutoMesh_VolumeEdge3D* edge;
  /* $BNG@~%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoMesh_Node3D* srcNode;
  /* $B%3!<%9@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *srcNodes_destNodeId;
  /* $B%U%!%$%s@aE@%l%3!<%I(BID$B%+%i%`(B
     ($B%3!<%9@aE@$+$i%U%!%$%s@aE@$X$N;2>H(B) */
  
  AutoMesh_VolumeElement3D* srcElement;
  /* $B%3!<%9MWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_Integer1DColumn *srcElements_destElementIds;  /* [8] */
  /* $B%U%!%$%sMWAG%l%3!<%I(BID$B%+%i%`(B
     ($B%3!<%9MWAG$+$i%U%!%$%sMWAG$X$N;2>H(B) */

  AutoMesh_Node3D *destNode;  /* CREATE */
  /* $B%U%!%$%s@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_Integer1DColumn *destNodes_srcNodeIds;  /* [2] */
  /* $B%3!<%9@aE@%l%3!<%I(BID$B%+%i%`(B
     ($B%U%!%$%s@aE@$+$i%3!<%9@aE@$X$N;2>H(B) */
  /* order is, 1st nodes, followed by, 2nd nodes */
  /* 1st node : [0] = nodeId, [1] = -1 */
  /* 2nd node : [0] = nodeId0, [1] = nodeId1 */

  AutoMesh_VolumeElement3D* destElement;  /* CREATE */
  /* $B%U%!%$%sMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *destElements_srcElementId;
  /* $B%3!<%9MWAG%l%3!<%I(BID$B%+%i%`(B
     ($B%U%!%$%sMWAG$+$i%3!<%9MWAG$X$N;2>H(B) */
  AutoRes_IntegerColumn *destElements_srcElementPartId;
  /* $B%3!<%9MWAG$G$NItJ,HV9f%+%i%`(B
     ($B%U%!%$%sMWAG$+$i%3!<%9MWAG$X$N;2>H(B) */
} AutoMesh_VolumeDivider3D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeDivider3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeDivider3D *AutoMesh_VolumeDivider3D_New 
(AutoMesh_VolumeEdge3D *edge);
/* $B6u$N(B<destNode>, <destElement>$B$,$=$l$>$l@8@.$5$l$k!#(B*/

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeDivider3D_delete 
(AutoMesh_VolumeDivider3D *self);
/* <destNode>, <destElement>$B$OGK4~$5$l$J$$$N$GCm0U!#(B*/

/* $B:n6H$r9T$&!#(B */
int /* boolean */
AutoMesh_VolumeDivider3D_do 
(AutoMesh_VolumeDivider3D *self,
 int srcNodeIdsFlag,
 int srcElementIdFlag,
 int destNodeIdFlag,
 int destElementIdsFlag);
/* srcNodeIdsFlag : 
   $B%U%!%$%s@aE@$+$i%3!<%9@aE@$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */
/* srcElementIdFlag : 
   $B%U%!%$%sMWAG$+$i%3!<%9MWAG$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */
/* destNodeIdFlag : 
   $B%3!<%9@aE@$+$i%U%!%$%s@aE@$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */
/* destElementIdsFlag : 
   $B%3!<%9MWAG$+$i%U%!%$%sMWAG$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */

/* $B%3!<%9@aE@$+$i%U%!%$%s@aE@$X$N;2>H(B */
/* $B;XDj$N%3!<%9@aE@%l%3!<%I$K$*$1$k%U%!%$%s@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeDivider3D_destNodeIdAtSrcNode
(AutoMesh_VolumeDivider3D *self,
 int srcNodeId);

/* $B%3!<%9MWAG$+$i%U%!%$%sMWAG$X$N;2>H(B */
/* $B;XDj$N%3!<%9MWAG%l%3!<%I$K$*$1$k%U%!%$%sMWAG%l%3!<%I(BID$B$r5a$a$k!#(B */
void AutoMesh_VolumeDivider3D_getDestElementIdsAtSrcElement
(AutoMesh_VolumeDivider3D *self,
 int srcElementId,
 int destElementIds_OUT[8]);
/* destElementIds_OUT[8] : $BMWAG%l%3!<%I(BID(8$B8D(B) */

/* $B%U%!%$%s@aE@$+$i%3!<%9@aE@$X$N;2>H(B */
/* $B;XDj$N%U%!%$%s@aE@%l%3!<%I$K$*$1$k%3!<%9@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
void AutoMesh_VolumeDivider3D_getSrcNodeIdsAtDestNode
(AutoMesh_VolumeDivider3D *self,
 int destNodeId,
 int srcNodeIds_OUT[2]);
/* $B0l<!@aE@$G$"$l$P!"(B*/
/* srcNodeIds_OUT[0] : $BBP1~$9$k@aE@%l%3!<%I(BID */
/* srcNodeIds_OUT[1] : -1 */
/* $BCf4V@aE@$G$"$l$P!"(B*/
/* srcNodeIds_OUT[0] : $BBP1~$9$kJU$NC<E@(B0$B$N@aE@%l%3!<%I(BID */
/* srcNodeIds_OUT[1] : $BBP1~$9$kJU$NC<E@(B1$B$N@aE@%l%3!<%I(BID */

/* $B%U%!%$%sMWAG$+$i%3!<%9MWAG$X$N;2>H(B */
/* $B;XDj$N%U%!%$%sMWAG%l%3!<%I$K$*$1$k%3!<%9MWAG%l%3!<%I(BID$B$r5a$a$k!#(B */
void AutoMesh_VolumeDivider3D_getSrcElementAtDestElement
(AutoMesh_VolumeDivider3D *self,
 int destElementId,
 int *srcElementId_OUT,
 int *srcElementPartId_OUT);
/* srcElementId_OUT : $BMWAG%l%3!<%I(BID */
/* srcElementPartId_OUT : $BItJ,HV9f(B */



#endif  /* __AUTOMESH_VOLUME_DIVIDER3D__ */



