/* header file for automesh_volume_edge3d.c */

#ifndef __AUTOMESH_VOLUME_EDGE3D__
#define __AUTOMESH_VOLUME_EDGE3D__



/* VolumeEdge3D */

/* $B%\%j%e!<%`MWAG$NNG@~%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_VolumeEdge3D {
  AutoRes_Handle handle;

  AutoMesh_PolyhedronType polyhedronType;
  /* $BB?LLBN%?%$%W(B */
  int nElementEdges;
  /* $BMWAG$"$?$j$NJU?t(B */

  AutoMesh_VolumeElement3D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_Integer1DColumn *elements_edgeIds;  /* [nElementEdges] */
  /* $BNG@~%l%3!<%I(BID$B%+%i%`(B
     ($BMWAGNG@~;2>H(B) */

  AutoRes_Table *edges;  /* OWN */
  /* $BNG@~%F!<%V%k(B */
  AutoRes_Integer1DColumn *edges_vertexNodeIds; /* [2], WORK AREA */
  /* 2$BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`(B
     ($BD:E@@aE@;2>H(B) */
} AutoMesh_VolumeEdge3D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeEdge3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeEdge3D *AutoMesh_VolumeEdge3D_New 
(AutoMesh_VolumeElement3D *element);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeEdge3D_delete 
(AutoMesh_VolumeEdge3D *self);

/* $BMWAGNG@~;2>H(B */
/* $BMWAG%l%3!<%I$4$H$NNG@~%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$NMWAG%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_VolumeEdge3D_makeEdgeIdsAtElementColumn 
(AutoMesh_VolumeEdge3D *self);

/* $BD:E@@aE@;2>H(B */
/* 2$BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_VolumeEdge3D_makeVertexNodeIdsColumn 
(AutoMesh_VolumeEdge3D *self);

/* $BNG@~$rCj=P$9$k!#(B */
int /* boolean */
AutoMesh_VolumeEdge3D_extract 
(AutoMesh_VolumeEdge3D *self);

/* $B:n6HMQ%a%b%jNN0h$rGK4~$9$k!#(B */
/* $BD:E@@aE@%+%i%`$,:o=|$5$l$k!#(B */
void AutoMesh_VolumeEdge3D_purgeWorkArea 
(AutoMesh_VolumeEdge3D *self);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_VolumeEdge3D_nEdges 
(AutoMesh_VolumeEdge3D *self);

/* $BD:E@@aE@;2>H(B */
/* $B;XDj%l%3!<%I$N(B2$BD:E@>e$N@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
void AutoMesh_VolumeEdge3D_getVertexNodeIdsAt 
(AutoMesh_VolumeEdge3D *self,
 int edgeId,
 int *nodeId0_OUT, int *nodeId1_OUT);

/* $B;XDj%l%3!<%I$NCfE@:BI8$r5a$a$k!#(B */
void AutoMesh_VolumeEdge3D_getMidPointAt 
(AutoMesh_VolumeEdge3D *self,
 int edgeId,
 double *x_OUT, double *y_OUT, double *z_OUT);

/* $BMWAGNG@~;2>H(B */
/* $B;XDjMWAG%l%3!<%I!"MWAGJUHV9f$K$*$1$kNG@~%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeEdge3D_edgeIdAtElement 
(AutoMesh_VolumeEdge3D *self,
 int elementId,
 int elementEdgeNum);



#endif  /* __AUTOMESH_VOLUME_EDGE3D__ */



