/* header file for automesh_volume_element3d.c */

#ifndef __AUTOMESH_VOLUME_ELEMENT3D__
#define __AUTOMESH_VOLUME_ELEMENT3D__



struct _AutoMesh_NodeScalar3D;
struct _AutoMesh_NodeVector3D;



/* VolumeElement3D */

/*
  AutoMesh$B!V$*$?$a$7!W$K$*$1$kMWAG@aE@%3%M%/%F%#%S%F%#(B
  ($BMWAG%3%M%/%F%#%S%F%#%+%i%`$NG[Ns=g=x$K4X$9$k7h$^$j(B)

  $B0l<!@aE@$OD:E@>e$K$"$k@aE@$G$"$k!#(B
  $B$7$?$,$C$F!"3F0l<!@aE@$OD:E@$H0lBN0l$GBP1~$9$k!#(B
  $B$3$N$H$-!"0l<!@aE@$NJB$S$O!"D:E@$NJB$S$HF1$8$K$J$k!#(B
  $B$3$l$i$OMWAG%3%M%/%F%#%S%F%#G[Ns$N:G=i$KG[CV$5$l$k!#(B

  $B$b$7!"$9$Y$F$NFs<!@aE@$,JU>e$NCf4V@aE@$G$"$l$P!"(B
  $B3FFs<!MWAG$OJU$H0lBN0l$GBP1~$9$k!#(B
  $B$3$N$H$-!"Fs<!@aE@$NJB$S$O!"JU$NJB$S$HF1$8$K$J$k!#(B
  $B$3$l$i$OMWAG%3%M%/%F%#%S%F%#G[Ns$K$*$$$F0l<!@aE@$N<!$KG[CV$5$l$k!#(B

  $B$=$l0J>e$N9b<!@aE@$O0lHL$KJU>e!"LL>e$"$k$$$OMWAGFbIt$K$"$j!"(B
  $B$3$l$i$OMWAG%3%M%/%F%#%S%F%#G[Ns$K$*$$$F0l<!MWAG$N8e$KG[CV$5$l$k!#(B
 */

/* $B%\%j%e!<%`MWAG%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_VolumeElement3D {
  AutoRes_Handle handle;

  AutoMesh_PolyhedronType polyhedronType;
  /* $BB?LLBN%?%$%W(B */
  int nElementNodes;
  /* $BMWAG$"$?$j$N@aE@?t(B */
  int nElementVertexs;
  /* $BMWAG$"$?$j$ND:E@?t(B */
  int nElementEdges;
  /* $BMWAG$"$?$j$NJU?t(B */
  int nElementFaces;
  /* $BMWAG$"$?$j$NLL?t(B */
  AutoMesh_Node3D *node;
  /* $B@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoRes_Table *elements;  /* OWN */
  /* $BMWAG%F!<%V%k(B */
  AutoRes_Integer1DColumn *elements_nodeIds;  /* [nElementNodes] */
  /* $B@aE@%l%3!<%I(BID$B%+%i%`(B
     ($BMWAG%3%M%/%F%#%S%F%#(B) */
  AutoRes_Integer1DColumn *elements_neighborIds;  /* [nElementFaces] */
  /* $BNY@\MWAG%l%3!<%I(BID$B%+%i%`(B
     ($BNY@\MWAG4X78(B) */

  AutoRes_Bucket3D *bucket;  /* OWN */
  /* $B8!:wMQ%P%1%C%H(B */

} AutoMesh_VolumeElement3D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeElement3D)

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeElement3D *AutoMesh_VolumeElement3D_New 
(AutoMesh_Node3D *node,
 AutoMesh_PolyhedronType polyhedronType,
 int nElementNodes);
/* polyhedronType : $BB?LLBN%?%$%W(B */
/* nElementNodes : $BMWAG$"$?$j$N@aE@?t(B */

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeElement3D_delete 
(AutoMesh_VolumeElement3D *self);

/* $B;XDj$N%l%3!<%I?t$r@_Dj$9$k!#(B*/
/* $B$=$NJ,$N%l%3!<%I$,$^$H$a$F@8@.$5$l$k!#(B */
/* $B$3$l$^$G$K@8@.$5$l$?%+%i%`J,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */ 
AutoMesh_VolumeElement3D_allocateElements 
(AutoMesh_VolumeElement3D *self,
 int nElements);

/* $B;XDj?t$N%l%3!<%I$rM=Ls$9$k!#(B */
/* $B$?$@$7!"%l%3!<%I?t<+BN$O(B0$B$N$^$^!#(B */
/* $B$3$l$^$G$K@8@.$5$l$?%+%i%`J,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */ 
AutoMesh_VolumeElement3D_reserveElements 
(AutoMesh_VolumeElement3D *self,
 int nElements);

/* $B%l%3!<%I$r0l$D?75,$KDI2C$9$k!#(B */
/* $B$3$l$K$h$j!"%l%3!<%I?t$O(B1$B$DA}$($k!#(B */
int AutoMesh_VolumeElement3D_addElement 
(AutoMesh_VolumeElement3D *self);

/* $B@aE@%3%M%/%F%#%S%F%#(B */
/* $B@aE@%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_VolumeElement3D_makeNodeIdsColumn 
(AutoMesh_VolumeElement3D *self);

/* $B@aE@%3%M%/%F%#%S%F%#(B */
/* $B;XDj%l%3!<%I!"@aE@HV9f$N@aE@%l%3!<%I(BID$B$r@_Dj$9$k!#(B */
void AutoMesh_VolumeElement3D_setNodeIdAt 
(AutoMesh_VolumeElement3D *self,
 int elementId,
 int elementNodeNum,
 int nodeId);

/* $BNY@\MWAG4X78(B */
/* $BNY@\MWAG%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_VolumeElement3D_makeNeighborIdsColumn 
(AutoMesh_VolumeElement3D *self);

/* $BNY@\MWAG4X78(B */
/* $B;XDj%l%3!<%I!"LLHV9f$GNY@\$9$kMWAG%l%3!<%I(BID$B$r@_Dj$9$k!#(B */
void AutoMesh_VolumeElement3D_setNeighborIdAt 
(AutoMesh_VolumeElement3D *self,
 int elementId,
 int elementFaceNum,
 int neighborId);

/* $B8!:wMQ%P%1%C%H$r@8@.$9$k!#(B */
int /* boolean */
AutoMesh_VolumeElement3D_makeBucket 
(AutoMesh_VolumeElement3D *self);

/* NO-TEST */
/* $B;XDj%l%3!<%I$K$D$$$F%j%J%s%P%j%s%0MQ$K@aE@$r%^!<%/$9$k!#(B */
void AutoMesh_VolumeElement3D_markElementForNodeRenumbering 
(AutoMesh_VolumeElement3D *self,
 int elementId);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_VolumeElement3D_nElements 
(AutoMesh_VolumeElement3D *self);

/* $B@aE@%3%M%/%F%#%S%F%#(B */
/* $B;XDj%l%3!<%I!"@aE@HV9f$N@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeElement3D_nodeIdAt 
(AutoMesh_VolumeElement3D *self,
 int elementId,
 int elementNodeNum);

/* $BNY@\MWAG4X78(B */
/* $B;XDj%l%3!<%I!"LLHV9f$GNY@\$9$kMWAG%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeElement3D_neighborIdAt 
(AutoMesh_VolumeElement3D *self,
 int elementId,
 int elementFaceNum);

/* $B;XDj%l%3!<%I$,@j$a$k6u4VNN0hHO0O$r5a$a$k!#(B */
void AutoMesh_VolumeElement3D_getRangeAt
(AutoMesh_VolumeElement3D *self,
 int elementId, 
 double *minRangeX_OUT, double *minRangeY_OUT, double *minRangeZ_OUT,
 double *maxRangeX_OUT, double *maxRangeY_OUT, double *maxRangeZ_OUT);

/* $B;XDj%l%3!<%I$NJ?6QNG@~D9$5(B($BMWAG%5%$%:(B)$B$r5a$a$k!#(B */
double AutoMesh_VolumeElement3D_averageEdgeLengthAt
(AutoMesh_VolumeElement3D *self,
 int elementId);

/* $B;XDj%l%3!<%I$,;XDj:BI8$r4^$`$+$I$&$+!#(B */
int /* boolean */
AutoMesh_VolumeElement3D_containsPointAt 
(AutoMesh_VolumeElement3D *self,
 int elementId, 
 double x, double y, double z,
 double *lx_OUT, double *ly_OUT, double *lz_OUT);
/* lx_OUT, ly_OUT, lz_OUT : $BMWAG6I=j:BI8(B */

/* NO-TEST */
/* $B;XDj%l%3!<%I$N;XDj6I=j:BI8$K$*$$$FJd4V$7$?%9%+%i!<CM$r5a$a$k!#(B */
double AutoMesh_VolumeElement3D_scalarAt
(AutoMesh_VolumeElement3D *self,
 int elementId,
 struct _AutoMesh_NodeScalar3D *scalar,
 double lx, double ly, double lz);

/* NO-TEST */
/* $B;XDj%l%3!<%I$N;XDj6I=j:BI8$K$*$$$FJd4V$7$?%Y%/%H%kCM$r5a$a$k!#(B */
void AutoMesh_VolumeElement3D_getVectorAt
(AutoMesh_VolumeElement3D *self,
 int elementId,
 struct _AutoMesh_NodeVector3D *vector,
 double lx, double ly, double lz,
 double *vectorX_OUT, double *vectorY_OUT, double *vectorZ_OUT);

/* $B;XDj:BI8$r4^$`MWAG$r8+IU$1$k!#(B */
int AutoMesh_VolumeElement3D_findElementUsingBucket 
(AutoMesh_VolumeElement3D *self,
 double x, double y, double z,
 double *lx_OUT, double *ly_OUT, double *lz_OUT);
/* $B8+IU$+$l$P!"MWAG%l%3!<%I(BID$B$rJV$9!#(B */
/* lx_OUT, ly_OUT, lz_OUT : $BMWAG6I=j:BI8(B */

/* $B;XDj%l%3!<%I$N$=$P$K$"$k!";XDj:BI8$r4^$`MWAG$r8+IU$1$k!#(B */
int AutoMesh_VolumeElement3D_findElementNear 
(AutoMesh_VolumeElement3D *self,
 int elementId, 
 double x, double y, double z,
 double *lx_OUT, double *ly_OUT, double *lz_OUT);
/* $B8+IU$+$l$P!"MWAG%l%3!<%I(BID$B$rJV$9!#(B */
/* lx_OUT, ly_OUT, lz_OUT : $BMWAG6I=j:BI8(B */



#endif  /* __AUTOMESH_VOLUME_ELEMENT3D__ */
