/* header file for automesh_volume_extractor2d.c */

#ifndef __AUTOMESH_VOLUME_EXTRACTOR2D__
#define __AUTOMESH_VOLUME_EXTRACTOR2D__



/* VolumeExtractor2D */

/* $BA*BrMWAG$rCj=P$9$k%/%i%9(B */
typedef struct _AutoMesh_VolumeExtractor2D {
  AutoRes_Handle handle;

  AutoRes_Selection *elementSelection;
  /* $BA*BrMWAG$N%;%l%/%7%g%s(B */

  AutoMesh_Node2D* srcNode;
  /* $B4{B8@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *srcNodes_destNodeId;
  /* $B?75,@aE@%l%3!<%I(BID$B%+%i%`(B
     ($B4{B8@aE@$+$i?75,@aE@$X$N;2>H(B) */
  
  AutoMesh_VolumeElement2D* srcElement;
  /* $B4{B8MWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *srcElements_destElementId;  
  /* $B?75,MWAG%l%3!<%I(BID$B%+%i%`(B
     ($B4{B8MWAG$+$i?75,MWAG$X$N;2>H(B) */

  AutoMesh_Node2D *destNode;  /* CREATE */
  /* $B?75,@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *destNodes_srcNodeId;  
  /* $B4{B8@aE@%l%3!<%I(BID$B%+%i%`(B
     ($B?75,@aE@$+$i4{B8@aE@$X$N;2>H(B) */

  AutoMesh_VolumeElement2D* destElement;  /* CREATE */
  /* $B?75,MWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *destElements_srcElementId;
  /* $B4{B8MWAG%l%3!<%I(BID$B%+%i%`(B
     ($B?75,MWAG$+$i4{B8MWAG$X$N;2>H(B) */
} AutoMesh_VolumeExtractor2D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeExtractor2D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeExtractor2D *AutoMesh_VolumeExtractor2D_New 
(AutoMesh_VolumeElement2D* element,
 AutoRes_Selection *elementSelection);
/* $B6u$N(B<destNode>, <destElement>$B$,$=$l$>$l@8@.$5$l$k!#(B*/

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeExtractor2D_delete 
(AutoMesh_VolumeExtractor2D *self);
/* <destNode>, <destElement>$B$OGK4~$5$l$J$$$N$GCm0U!#(B*/

/* $B:n6H$r9T$&!#(B */
int /* boolean */
AutoMesh_VolumeExtractor2D_do 
(AutoMesh_VolumeExtractor2D *self,
 int nodeFlag,
 int elementFlag,
 int srcElementIdFlag,
 int destElementIdFlag,
 int srcNodeIdFlag);
/* nodeFlag : $B@aE@:BI8$r@8@.$9$k$+$I$&$+!#(B */
/* elementFlag : $BMWAG%3%M%/%F%#%S%F%#$r@8@.$9$k$+$I$&$+!#(B */
/* srcElementIdsFlag : 
   $B?75,MWAG$+$i4{B8MWAG$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */
/* destElementIdFlag : 
   $B4{B8MWAG$+$i?75,MWAG$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */
/* srcNodeIdsFlag : 
   $B?75,@aE@$+$i4{B8@aE@$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */

/* $B4{B8@aE@$+$i?75,@aE@$X$N;2>H(B */
/* $B;XDj$N4{B8@aE@%l%3!<%I$K$*$1$k?75,@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeExtractor2D_destNodeIdAtSrcNode
(AutoMesh_VolumeExtractor2D *self,
 int srcNodeId);

/* $B?75,@aE@$+$i4{B8@aE@$X$N;2>H(B */
/* $B;XDj$N?75,@aE@%l%3!<%I$K$*$1$k4{B8@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeExtractor2D_srcNodeIdAtDestNode
(AutoMesh_VolumeExtractor2D *self,
 int destNodeId);

/* $B4{B8MWAG$+$i?75,MWAG$X$N;2>H(B */
/* $B;XDj$N4{B8MWAG%l%3!<%I$K$*$1$k?75,MWAG%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeExtractor2D_destElementIdAtSrcElement
(AutoMesh_VolumeExtractor2D *self,
 int srcElementId);

/* $B?75,MWAG$+$i4{B8MWAG$X$N;2>H(B */
/* $B;XDj$N?75,MWAG%l%3!<%I$K$*$1$k4{B8MWAG%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeExtractor2D_srcElementIdAtDestElement
(AutoMesh_VolumeExtractor2D *self,
 int destElementId);



#endif  /* __AUTOMESH_VOLUME_EXTRACTOR2D__ */



