/* header file for automesh_volume_face3d.c */

#ifndef __AUTOMESH_VOLUME_FACE3D__
#define __AUTOMESH_VOLUME_FACE3D__



/* VolumeFace3D */

/* $B%\%j%e!<%`MWAG$NI=LL%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_VolumeFace3D {
  AutoRes_Handle handle;

  AutoMesh_PolyhedronType polyhedronType;
  /* $BB?LLBN%?%$%W(B */
  int nElementFaces;
  /* $BMWAG$"$?$j$NLL?t(B */

  AutoMesh_VolumeElement3D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_Integer1DColumn *elements_faceIds;  /* [nElementFaces] */
  /* $BI=LL%l%3!<%I(BID$B%+%i%`(B
     ($BMWAGI=LL;2>H(B) */

  AutoRes_Table *faces;  /* OWN */
  /* $BI=LL%F!<%V%k(B */
  AutoRes_Integer1DColumn *faces_vertexNodeIds;  /* [nFaceVertexs], WORK AREA */
  /* $BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`(B
     ($BD:E@@aE@;2>H(B) */
  AutoRes_Integer1DColumn *faces_elementIds;  /* [2] */
  /* $BN>%5%$%I$K$"$kMWAG%l%3!<%I(BID$B%+%i%`(B
     ($B%5%$%IMWAG;2>H(B) */
  AutoRes_Integer1DColumn *faces_elementFaceNums;  /* [2] */
  /* $BN>%5%$%I$K$"$kMWAG$NMWAGLLHV9f%+%i%`(B
     ($B%5%$%IMWAG;2>H(B) */
} AutoMesh_VolumeFace3D;

/* faces_elementIds[0] is not -1 */
/* faces_elementIds[1] can be -1, if so, it is on boundary */

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeFace3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeFace3D *AutoMesh_VolumeFace3D_New 
(AutoMesh_VolumeElement3D *element);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeFace3D_delete 
(AutoMesh_VolumeFace3D *self);

/* $BMWAGI=LL;2>H(B */
/* $BMWAG%l%3!<%I$4$H$NI=LL%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$NMWAG%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_VolumeFace3D_makeFaceIdsAtElementColumn 
(AutoMesh_VolumeFace3D *self);

/* $BD:E@@aE@;2>H(B */
/* $BD:E@>e$N@aE@%l%3!<%I(BID$B%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_VolumeFace3D_makeVertexNodeIdsColumn 
(AutoMesh_VolumeFace3D *self,
 int nFaceVertexs);

/* $B%5%$%IMWAG;2>H(B */
/* $BMWAG%l%3!<%I(BID$B%+%i%`$*$h$SMWAGLLHV9f%+%i%`$r@8@.$9$k!#(B */
/* $B8=;~E@$G$N%l%3!<%I?t(B($B$"$k$$$OM=Ls?t(B)$BJ,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */
AutoMesh_VolumeFace3D_makeElementIdsColumn 
(AutoMesh_VolumeFace3D *self);

/* $BI=LL$rCj=P$9$k!#(B */
int /* boolean */
AutoMesh_VolumeFace3D_extract 
(AutoMesh_VolumeFace3D *self,
 int elementIdsFlag);
/* elementIdsFlag : $B%5%$%IMWAG;2>H$r@8@.$9$k$+$I$&$+!#(B */

/* $B:n6HMQ%a%b%jNN0h$rGK4~$9$k!#(B */
/* $BD:E@@aE@%+%i%`$,:o=|$5$l$k!#(B */
void AutoMesh_VolumeFace3D_purgeWorkArea 
(AutoMesh_VolumeFace3D *self);

/* $BMWAGNY@\4X78$r:n@.$9$k!#(B */
/* $BMWAG%F!<%V%k$KNY@\4X78$r@_Dj$9$k!#(B */
int AutoMesh_VolumeFace3D_collectNeighbor 
(AutoMesh_VolumeFace3D *self);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_VolumeFace3D_nFaces 
(AutoMesh_VolumeFace3D *self);

/* $B%5%$%IMWAG;2>H(B */
/* $B;XDj%l%3!<%I$NN>%5%$%I$K$*$1$kMWAG%l%3!<%I(BID$B$*$h$SMWAGLLHV9f$r5a$a$k!#(B */
void AutoMesh_VolumeFace3D_getFaceAt 
(AutoMesh_VolumeFace3D *self,
 int faceId,
 int elementIds_OUT[2],
 int elementFaceNums_OUT[2]);
/* elementIds_OUT : $BMWAG%l%3!<%I(BID$B$^$?$O(B-1 */

/* $B;XDj%l%3!<%I$,6-3&>e$K$"$k$+$I$&$+!#(B */
int /* boolean */
AutoMesh_VolumeFace3D_isOnBoundaryAt 
(AutoMesh_VolumeFace3D *self,
 int faceId);

/* $B%5%$%IMWAG;2>H(B */
/* $B$b$7!";XDj%l%3!<%I$,6-3&>e$K$"$l$P!"(B
   $B$=$NFbB&$K$"$kMWAG%l%3!<%I(BID$B$HMWAGLLHV9f$r5a$a$k!#(B */
int /* boolean */
AutoMesh_VolumeFace3D_getBoundaryAt 
(AutoMesh_VolumeFace3D *self,
 int faceId,
 int *elementId_OUT,
 int *elementFaceNum_OUT);
/* $B6-3&>e$K$"$k$+$I$&$+$rJV$9!#(B */

/* $BMWAGI=LL;2>H(B */
/* $B;XDjMWAG%l%3!<%I!"MWAGLLHV9f$K$*$1$kI=LL%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeFace3D_faceIdAtElement 
(AutoMesh_VolumeFace3D *self,
 int elementId,
 int elementFaceNum);



#endif  /* __AUTOMESH_VOLUME_FACE3D__ */



