/* header file for automesh_volume_isosurface3d.c */

#ifndef __AUTOMESH_VOLUME_ISOSURFACE3D__
#define __AUTOMESH_VOLUME_ISOSURFACE3D__



/* VolumeIsosurface3D */

/* $B%\%j%e!<%`EyCMLL%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_VolumeIsosurface3D {
  AutoRes_Handle handle;

  AutoMesh_Node3D *node;
  /* $B@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoMesh_VolumeElement3D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoMesh_NodeScalar3D *scalar;
  /* $B@aE@%9%+%i!<%$%s%9%?%s%9$X$N;2>H(B */

  AutoRes_Table *isosurfaces;  /* OWN */
  /* $BEyCMLL%F!<%V%k(B */
  AutoRes_IntegerColumn *isosurfaces_elementId;  
  /* $BMWAG%l%3!<%I(BID$B%+%i%`(B */
  AutoRes_Integer1DColumn *isosurfaces_elementEdgeNums;  /* [3] */
  /* $BMWAGJUHV9f%+%i%`(B */
  AutoRes_Real1DColumn *isosurfaces_ratios;  /* [3] */
  /* $BMWAGJU>e$NJ,3dHfN(%+%i%`(B */
} AutoMesh_VolumeIsosurface3D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeIsosurface3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeIsosurface3D *AutoMesh_VolumeIsosurface3D_New 
(AutoMesh_VolumeElement3D *element,
 AutoMesh_NodeScalar3D *scalar);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeIsosurface3D_delete 
(AutoMesh_VolumeIsosurface3D *self);

/* $BI,MW$JA4$F$N%+%i%`$r@8@.$9$k!#(B */
int /* boolean */
AutoMesh_VolumeIsosurface3D_makeColumn 
(AutoMesh_VolumeIsosurface3D *self);

/* $BEyCMLL$rCj=P$9$k!#(B */
int /* boolean */
AutoMesh_VolumeIsosurface3D_extract 
(AutoMesh_VolumeIsosurface3D *self,
 double levelValue);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_VolumeIsosurface3D_nIsosurfaces 
(AutoMesh_VolumeIsosurface3D *self);

/* $B;XDj%l%3!<%I$NMWAG%l%3!<%I(BID$B$*$h$S(B3$BJU$NMWAGJUHV9f$HHfN($r5a$a$k!#(B */
void AutoMesh_VolumeIsosurface3D_getIsosurfaceAt 
(AutoMesh_VolumeIsosurface3D *self,
 int isosurfaceId,
 int *elementId_OUT,
 int *elementEdgeNum0_OUT, double *ratio0_OUT, 
 int *elementEdgeNum1_OUT, double *ratio1_OUT, 
 int *elementEdgeNum2_OUT, double *ratio2_OUT);

/* $B;XDj%l%3!<%I$N(B3$BD:E@$N:BI8$r5a$a$k!#(B */
void AutoMesh_VolumeIsosurface3D_getIsosurfacePointAt 
(AutoMesh_VolumeIsosurface3D *self,
 int isosurfaceId,
 double *x0_OUT, double *y0_OUT, double *z0_OUT, 
 double *x1_OUT, double *y1_OUT, double *z1_OUT, 
 double *x2_OUT, double *y2_OUT, double *z2_OUT);



#endif  /* __AUTOMESH_VOLUME_ISOSURFACE3D__ */



