/* header file for automesh_volume_mid_node_generator2d.c */

#ifndef __AUTOMESH_VOLUME_MID_NODE_GENERATOR2D__
#define __AUTOMESH_VOLUME_MID_NODE_GENERATOR2D__



/* VolumeMidNodeGenerator2D */

/* $BCf4V@aE@$r@8@.$7!"0l<!MWAG%a%C%7%e$+$iFs<!MWAG%a%C%7%e$r@8@.$9$k%/%i%9(B */
typedef struct _AutoMesh_VolumeMidNodeGenerator2D {
  AutoRes_Handle handle;

  AutoMesh_VolumeEdge2D* edge;
  /* $BNG@~%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoMesh_Node2D* srcNode;
  /* $BDc<!B&@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_IntegerColumn *srcNodes_destNodeId;
  /* $B9b<!B&@aE@%l%3!<%I(BID$B%+%i%`(B
     ($BDc<!B&@aE@$+$i9b<!B&@aE@$X$N;2>H(B) */
  
  AutoMesh_VolumeElement2D* srcElement;
  /* $BDc<!B&MWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoMesh_Node2D *destNode;  /* CREATE */
  /* $B9b<!B&@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_Integer1DColumn *destNodes_srcNodeIds;  /* [2] */
  /* $BDc<!B&@aE@%l%3!<%I(BID$B%+%i%`(B
     ($B9b<!B&@aE@$+$iDc<!B&@aE@$X$N;2>H(B) */
  /* order is, 1st nodes, followed by, 2nd nodes */
  /* 1st node : [0] = nodeId, [1] = -1 */
  /* 2nd node : [0] = nodeId0, [1] = nodeId1 */

  AutoMesh_VolumeElement2D* destElement;  /* CREATE */
  /* $B9b<!B&MWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
} AutoMesh_VolumeMidNodeGenerator2D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeMidNodeGenerator2D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeMidNodeGenerator2D *AutoMesh_VolumeMidNodeGenerator2D_New 
(AutoMesh_VolumeEdge2D *edge);
/* $B6u$N(B<destNode>, <destElement>$B$,$=$l$>$l@8@.$5$l$k!#(B*/

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeMidNodeGenerator2D_delete 
(AutoMesh_VolumeMidNodeGenerator2D *self);
/* <destNode>, <destElement>$B$OGK4~$5$l$J$$$N$GCm0U!#(B*/

/* $B:n6H$r9T$&!#(B */
int /* boolean */
AutoMesh_VolumeMidNodeGenerator2D_do 
(AutoMesh_VolumeMidNodeGenerator2D *self,
 int nodeFlag,
 int elementFlag,
 int srcNodeIdsFlag,
 int destNodeIdFlag);
/* nodeFlag : $B@aE@:BI8$r@8@.$9$k$+$I$&$+!#(B */
/* elementFlag : $BMWAG%3%M%/%F%#%S%F%#$r@8@.$9$k$+$I$&$+!#(B */
/* srcNodeIdsFlag : 
   $B9b<!B&@aE@$+$iDc<!B&@aE@$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */
/* destNodeIdFlag : 
   $BDc<!B&@aE@$+$i9b<!B&@aE@$X$N;2>H$r@8@.$9$k$+$I$&$+!#(B */

/* $BDc<!B&@aE@$+$i9b<!B&@aE@$X$N;2>H(B */
/* $B;XDj$NDc<!B&@aE@%l%3!<%I$K$*$1$k9b<!B&@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
int AutoMesh_VolumeMidNodeGenerator2D_destNodeIdAtSrcNode
(AutoMesh_VolumeMidNodeGenerator2D *self,
 int srcNodeId);

/* $B9b<!B&@aE@$+$iDc<!B&@aE@$X$N;2>H(B */
/* $B;XDj$N9b<!B&@aE@%l%3!<%I$K$*$1$kDc<!B&@aE@%l%3!<%I(BID$B$r5a$a$k!#(B */
void AutoMesh_VolumeMidNodeGenerator2D_getSrcNodeIdsAtDestNode
(AutoMesh_VolumeMidNodeGenerator2D *self,
 int destNodeId,
 int srcNodeIds_OUT[2]);
/* $B0l<!@aE@$G$"$l$P!"(B*/
/* srcNodeIds_OUT[0] : $BBP1~$9$k@aE@%l%3!<%I(BID */
/* srcNodeIds_OUT[1] : -1 */
/* $BCf4V@aE@$G$"$l$P!"(B*/
/* srcNodeIds_OUT[0] : $BBP1~$9$kJU$NC<E@(B0$B$N@aE@%l%3!<%I(BID */
/* srcNodeIds_OUT[1] : $BBP1~$9$kJU$NC<E@(B1$B$N@aE@%l%3!<%I(BID */



#endif  /* __AUTOMESH_VOLUME_MID_NODE_GENERATOR2D__ */



