/* header file for automesh_volume_particle3d.c */

#ifndef __AUTOMESH_VOLUME_PARTICLE3D__
#define __AUTOMESH_VOLUME_PARTICLE3D__



/* VolumeParticle3D */

/* NO-TEST */
/* $B%\%j%e!<%`%Q!<%F%#%/%k%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_VolumeParticle3D {
  AutoRes_Handle handle;

  AutoMesh_Node3D *node;
  /* $B@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoMesh_VolumeElement3D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  int nParticles;
  /* $B%Q!<%F%#%/%k?t(B */
  int nSteps;
  /* $B;~4V%9%F%C%W?t(B */
  double deltaT;
  /* $B;~4V9o$_I}(B */

  AutoRes_Table *particles;  /* OWN, [nParticles] */
  /* $B%Q!<%F%#%/%k%F!<%V%k(B */
  AutoRes_Real1DColumn *particles_startCoord;  /* [3] */
  /* $B=i4|0LCV%+%i%`(B */

  AutoRes_Table *traces;  /* OWN, [nParticles][nSteps] */
  /* $B%Q!<%F%#%/%k50@W%F!<%V%k(B */
  AutoRes_Real1DColumn *traces_coord;  /* [3] */
  /* $B:BI8%+%i%`(B */
  AutoRes_IntegerColumn *traces_elementId;    
  /* $BMWAG%l%3!<%I(BID$B%+%i%`(B */
  AutoRes_Real1DColumn *traces_localCoord;  /* [3] */
  /* $BMWAG6I=j:BI8%+%i%`(B */

} AutoMesh_VolumeParticle3D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeParticle3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeParticle3D *AutoMesh_VolumeParticle3D_New 
(AutoMesh_VolumeElement3D *element);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeParticle3D_delete 
(AutoMesh_VolumeParticle3D *self);

/* $BI,MW$JA4$F$N%+%i%`$r@8@.$9$k!#(B */
int /* boolean */
AutoMesh_VolumeParticle3D_makeColumn 
(AutoMesh_VolumeParticle3D *self);

/* $B%Q!<%F%#%/%k?t$H;~9o%9%F%C%W?t$r@_Dj$9$k!#(B */
void AutoMesh_VolumeParticle3D_allocateParticle 
(AutoMesh_VolumeParticle3D *self,
 int nParticles,
 int nSteps);

/* $B;XDj%Q!<%F%#%/%k%l%3!<%I$N=i4|0LCV$r@_Dj$9$k!#(B */
void AutoMesh_VolumeParticle3D_setParticleStartPointAt 
(AutoMesh_VolumeParticle3D *self,
 int particleId,
 double x, double y, double z);

/* $B%Q!<%F%#%/%k$N50@W$r5a$a$k!#(B */
void AutoMesh_VolumeParticle3D_traceParticle 
(AutoMesh_VolumeParticle3D *self,
 AutoMesh_NodeVector3D *vector,
 double deltaT);
/* deltaT : $B;~9o9o$_I}(B */

/* $B%Q!<%F%#%/%k%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_VolumeParticle3D_nParticles
(AutoMesh_VolumeParticle3D *self);

/* $B;~4V%9%F%C%W?t$r5a$a$k!#(B */
int AutoMesh_VolumeParticle3D_nSteps
(AutoMesh_VolumeParticle3D *self);

/* $B;XDj%Q!<%F%#%/%k%l%3!<%I$N=i4|0LCV$r5a$a$k!#(B */
void AutoMesh_VolumeParticle3D_getParticleStartPointAt  
(AutoMesh_VolumeParticle3D *self,
 int particleId,
 double *x_OUT, double *y_OUT, double *z_OUT);

/* $B;XDj%Q!<%F%#%/%k!";~4V%9%F%C%W$G$N%Q!<%F%#%/%k50@W>pJs(B
   ($B0LCV!"MWAG%l%3!<%I(BID$B!"MWAG6I=j:BI8(B)$B$r5a$a$k!#(B */
void AutoMesh_VolumeParticle3D_getTraceAt 
(AutoMesh_VolumeParticle3D *self,
 int particleId,
 int step,
 double *x_OUT, double *y_OUT, double *z_OUT,
 int *elementId_OUT,
 double *lx_OUT, double *ly_OUT, double *lz_OUT);



#endif  /* __AUTOMESH_VOLUME_PARTICLE3D__ */



