/* header file for automesh_volume_sample3d.c */

#ifndef __AUTOMESH_VOLUME_SAMPLE3D__
#define __AUTOMESH_VOLUME_SAMPLE3D__



/* VolumeSample3D */

/* NO-TEST */
/* $B%\%j%e!<%`%5%s%W%kE@%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_VolumeSample3D {
  AutoRes_Handle handle;

  AutoMesh_Node3D *node;
  /* $B@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoMesh_VolumeElement3D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */

  AutoRes_Table *samples;  /* OWN */
  /* $B%5%s%W%kE@%F!<%V%k(B */
  AutoRes_Real1DColumn *samples_coord;  /* [3] */
  /* $B:BI8%+%i%`(B */
  AutoRes_IntegerColumn *samples_elementId;  
  /* $BMWAG%l%3!<%I(BID$B%+%i%`(B */
  AutoRes_Real1DColumn *samples_localCoord;  /* [3] */
  /* $BMWAG6I=j:BI8%+%i%`(B */

} AutoMesh_VolumeSample3D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeSample3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeSample3D *AutoMesh_VolumeSample3D_New 
(AutoMesh_VolumeElement3D *element);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeSample3D_delete 
(AutoMesh_VolumeSample3D *self);

/* $BI,MW$JA4$F$N%+%i%`$r@8@.$9$k!#(B */
int /* boolean */
AutoMesh_VolumeSample3D_makeColumn 
(AutoMesh_VolumeSample3D *self);

/* $B;XDj?t$N%l%3!<%I$rM=Ls$9$k!#(B */
/* $B$?$@$7!"%l%3!<%I?t<+BN$O(B0$B$N$^$^!#(B */
/* $B$3$l$^$G$K@8@.$5$l$?%+%i%`J,$N%a%b%j$,3NJ]$5$l$k!#(B */
int /* boolean */ 
AutoMesh_VolumeSample3D_reserveSamples 
(AutoMesh_VolumeSample3D *self,
 int nSamples);

/* $B%l%3!<%I$r0l$D?75,$KDI2C$9$k!#(B */
/* $B$3$l$K$h$j!"%l%3!<%I?t$O(B1$B$DA}$($k!#(B */
int AutoMesh_VolumeSample3D_addSample 
(AutoMesh_VolumeSample3D *self,
 double x, double y, double z);

/* $B3F%l%3!<%I$K$D$$$F!"BP1~$9$kMWAG$H$N%^%C%T%s%0$r:n@.$9$k!#(B */
void AutoMesh_VolumeSample3D_setElementOnSample 
(AutoMesh_VolumeSample3D *self);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_VolumeSample3D_nSamples 
(AutoMesh_VolumeSample3D *self);

/* $B;XDj%l%3!<%I$N:BI8$r5a$a$k!#(B */
void AutoMesh_VolumeSample3D_getSamplePointAt 
(AutoMesh_VolumeSample3D *self,
 int sampleId,
 double *x_OUT, double *y_OUT, double *z_OUT);

/* $B;XDj%l%3!<%I$NMWAG%l%3!<%I(BID$B$*$h$SMWAG6I=j:BI8$r5a$a$k!#(B */
void AutoMesh_VolumeSample3D_getSampleAt 
(AutoMesh_VolumeSample3D *self,
 int sampleId,
 int *elementId_OUT,
 double *lx_OUT, double *ly_OUT, double *lz_OUT);

/* $B;XDj%l%3!<%I$N%9%+%i!<Jd4VCM$r5a$a$k!#(B */
double AutoMesh_VolumeSample3D_scalarAt 
(AutoMesh_VolumeSample3D *self,
 int sampleId,
 AutoMesh_NodeScalar3D *scalar);

/* $B;XDj%l%3!<%I$N%Y%/%H%kJd4VCM$r5a$a$k!#(B */
void AutoMesh_VolumeSample3D_getVectorAt 
(AutoMesh_VolumeSample3D *self,
 int sampleId,
 AutoMesh_NodeVector3D *vector,
 double *valueX_OUT, double *valueY_OUT, double *valueZ_OUT);



#endif  /* __AUTOMESH_VOLUME_SAMPLE3D__ */



