/* header file for automesh_volume_section3d.c */

#ifndef __AUTOMESH_VOLUME_SECTION3D__
#define __AUTOMESH_VOLUME_SECTION3D__



/* VolumeSection3D */

/* $B%\%j%e!<%`CGLL%F!<%V%k%/%i%9(B */
typedef struct _AutoMesh_VolumeSection3D {
  AutoRes_Handle handle;

  AutoMesh_Node3D *node;
  /* $B@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_RealColumn *nodes_sectionValue;
  /* $BJ}Dx<0$NCM%+%i%`(B */

  AutoMesh_VolumeElement3D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  double a, b, c, d;
  /* $BJ?LL$NJ}Dx<0(B */

  AutoRes_Table *sections;  /* OWN */
  /* $BCGLL%F!<%V%k(B */
  AutoRes_IntegerColumn *sections_elementId;  
  /* $BMWAG%l%3!<%I(BID$B%+%i%`(B */
  AutoRes_Integer1DColumn *sections_elementEdgeNums;  /* [3] */
  /* $BMWAGJUHV9f%+%i%`(B */
  AutoRes_Real1DColumn *sections_ratios;  /* [3] */
  /* $BMWAGJU>e$NJ,3dHfN(%+%i%`(B */
} AutoMesh_VolumeSection3D;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeSection3D);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeSection3D *AutoMesh_VolumeSection3D_New 
(AutoMesh_VolumeElement3D *element);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeSection3D_delete 
(AutoMesh_VolumeSection3D *self);

/* $BI,MW$JA4$F$N%+%i%`$r@8@.$9$k!#(B */
int /* boolean */
AutoMesh_VolumeSection3D_makeColumn 
(AutoMesh_VolumeSection3D *self);

/* $BCGLL$NJ?LLJ}Dx<0$r@_Dj$9$k!#(B */
void AutoMesh_VolumeSection3D_setEquation 
(AutoMesh_VolumeSection3D *self,
 double a, double b, double c, double d);

/* $BCGLL$rCj=P$9$k!#(B */
int /* boolean */
AutoMesh_VolumeSection3D_extract 
(AutoMesh_VolumeSection3D *self,
 double offset);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_VolumeSection3D_nSections 
(AutoMesh_VolumeSection3D *self);

/* $B;XDj%l%3!<%I$NMWAG%l%3!<%I(BID$B$*$h$S(B3$BJU$NMWAGJUHV9f$HHfN($r5a$a$k!#(B */
void AutoMesh_VolumeSection3D_getSectionAt 
(AutoMesh_VolumeSection3D *self,
 int sectionId,
 int *elementId_OUT,
 int *elementEdgeNum0_OUT, double *ratio0_OUT, 
 int *elementEdgeNum1_OUT, double *ratio1_OUT, 
 int *elementEdgeNum2_OUT, double *ratio2_OUT);

/* $B;XDj%l%3!<%I$N(B3$BD:E@$N:BI8$r5a$a$k!#(B */
void AutoMesh_VolumeSection3D_getSectionPointAt 
(AutoMesh_VolumeSection3D *self,
 int sectionId,
 double *x0_OUT, double *y0_OUT, double *z0_OUT, 
 double *x1_OUT, double *y1_OUT, double *z1_OUT, 
 double *x2_OUT, double *y2_OUT, double *z2_OUT);

/* $B;XDj%l%3!<%I$N(B3$BD:E@$G$N%9%+%i!<CM$r5a$a$k!#(B */
void AutoMesh_VolumeSection3D_getSectionScalarAt 
(AutoMesh_VolumeSection3D *self,
 int sectionId,
 AutoMesh_NodeScalar3D *scalar,
 double *value0_OUT, double *value1_OUT, double *value2_OUT);



#endif  /* __AUTOMESH_VOLUME_SECTION3D__ */



