/* header file for automesh_volume_section3d2.c */

#ifndef __AUTOMESH_VOLUME_SECTION3D2__
#define __AUTOMESH_VOLUME_SECTION3D2__



/* VolumeSection3D2 */

/* $B%\%j%e!<%`CGLL%F!<%V%k%/%i%9(B */
/* $B%P%1%C%H8!:w%P!<%8%g%s(B */
typedef struct _AutoMesh_VolumeSection3D2 {
  AutoRes_Handle handle;

  AutoMesh_Node3D *node;
  /* $B@aE@%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  AutoRes_RealColumn *nodes_sectionValue;
  /* $BJ}Dx<0$NCM%+%i%`(B */

  AutoMesh_VolumeElement3D *element;
  /* $BMWAG%F!<%V%k%$%s%9%?%s%9$X$N;2>H(B */
  double a, b, c, d;
  /* $BJ?LL$NJ}Dx<0(B */

  AutoRes_Table *sections;  /* OWN */
  /* $BCGLL%F!<%V%k(B */
  AutoRes_IntegerColumn *sections_elementId;  
  /* $BMWAG%l%3!<%I(BID$B%+%i%`(B */
  AutoRes_Integer1DColumn *sections_elementEdgeNums;  /* [3] */
  /* $BMWAGJUHV9f%+%i%`(B */
  AutoRes_Real1DColumn *sections_ratios;  /* [3] */
  /* $BMWAGJU>e$NJ,3dHfN(%+%i%`(B */

  AutoRes_Bucket1D *bucket;  /* OWN */
  /* $B8!:wMQ%P%1%C%H(B */

} AutoMesh_VolumeSection3D2;

AUTORES_DECLARE_HANDLE(AutoMesh_VolumeSection3D2);

/* $B%/%i%9$N%$%s%9%?%s%9$r@8@.$9$k!#(B */
AutoMesh_VolumeSection3D2 *AutoMesh_VolumeSection3D2_New 
(AutoMesh_VolumeElement3D *element);

/* $B%/%i%9$N%$%s%9%?%s%9$rGK4~$9$k!#(B */
void AutoMesh_VolumeSection3D2_delete 
(AutoMesh_VolumeSection3D2 *self);

/* $BI,MW$JA4$F$N%+%i%`$r@8@.$9$k!#(B */
int /* boolean */
AutoMesh_VolumeSection3D2_makeColumn 
(AutoMesh_VolumeSection3D2 *self);

/* $BCGLL$NJ?LLJ}Dx<0$r@_Dj$9$k!#(B */
void AutoMesh_VolumeSection3D2_setEquation 
(AutoMesh_VolumeSection3D2 *self,
 double a, double b, double c, double d);

/* $B8!:wMQ%P%1%C%H$r:n@.$9$k!#(B */
int /* boolean */
AutoMesh_VolumeSection3D2_makeBucket 
(AutoMesh_VolumeSection3D2 *self);

/* $BCGLL$rCj=P$9$k!#(B */
int /* boolean */
AutoMesh_VolumeSection3D2_extract 
(AutoMesh_VolumeSection3D2 *self,
 double offset);

/* $B%l%3!<%I?t$r5a$a$k!#(B */
int AutoMesh_VolumeSection3D2_nSections 
(AutoMesh_VolumeSection3D2 *self);

/* $B;XDj%l%3!<%I$NMWAG%l%3!<%I(BID$B$*$h$S(B3$BJU$NMWAGJUHV9f$HHfN($r5a$a$k!#(B */
void AutoMesh_VolumeSection3D2_getSectionAt 
(AutoMesh_VolumeSection3D2 *self,
 int sectionId,
 int *elementId_OUT,
 int *elementEdgeNum0_OUT, double *ratio0_OUT, 
 int *elementEdgeNum1_OUT, double *ratio1_OUT, 
 int *elementEdgeNum2_OUT, double *ratio2_OUT);

/* $B;XDj%l%3!<%I$N(B3$BD:E@$N:BI8$r5a$a$k!#(B */
void AutoMesh_VolumeSection3D2_getSectionPointAt 
(AutoMesh_VolumeSection3D2 *self,
 int sectionId,
 double *x0_OUT, double *y0_OUT, double *z0_OUT, 
 double *x1_OUT, double *y1_OUT, double *z1_OUT, 
 double *x2_OUT, double *y2_OUT, double *z2_OUT);

/* $B;XDj%l%3!<%I$N(B3$BD:E@$G$N%9%+%i!<CM$r5a$a$k!#(B */
void AutoMesh_VolumeSection3D2_getSectionScalarAt 
(AutoMesh_VolumeSection3D2 *self,
 int sectionId,
 AutoMesh_NodeScalar3D *scalar,
 double *value0_OUT, double *value1_OUT, double *value2_OUT);



#endif  /* __AUTOMESH_VOLUME_SECTION3D2__ */



