M=$1

MODEL_IN_DIR=${M}_in
MODEL_OUT_DIR=${M}_out
COMMAND_DIR=../../command
VIEWER_DIR=../../autogl_command
ANGLE=30

cp ${MODEL_IN_DIR}/${M}.node .
cp ${MODEL_IN_DIR}/${M}.element .
cp ${MODEL_IN_DIR}/${M}.scalar .
cp ${MODEL_IN_DIR}/${M}.vector .
# cp ${MODEL_IN_DIR}/${M}_xt.selection .

#
echo advautomesh_tetra3d_edge
${COMMAND_DIR}/advautomesh_tetra3d_edge ${M}.node ${M}.element \
    ${M}.el_ed ${M}.ed_vt
diff ${M}.el_ed ${MODEL_OUT_DIR}/${M}.el_ed
diff ${M}.ed_vt ${MODEL_OUT_DIR}/${M}.ed_vt
#
echo advautomesh_tetra3d_face
${COMMAND_DIR}/advautomesh_tetra3d_face ${M}.node ${M}.element \
    ${M}.face ${M}.el_fc ${M}.el_nb
diff ${M}.face ${MODEL_OUT_DIR}/${M}.face
diff ${M}.el_fc ${MODEL_OUT_DIR}/${M}.el_fc
diff ${M}.el_nb ${MODEL_OUT_DIR}/${M}.el_nb
#
echo advautomesh_tetra3d_boundary_face
${COMMAND_DIR}/advautomesh_tetra3d_boundary_face ${M}.node ${M}.element \
    ${M}.bd_fc
diff ${M}.bd_fc ${MODEL_OUT_DIR}/${M}.bd_fc
#
echo advautomesh_tetra3d_boundary
${COMMAND_DIR}/advautomesh_tetra3d_boundary ${M}.node ${M}.element \
    ${M}.face \
    ${M}_B.node ${M}_B.element ${M}_B.src_nd ${M}_B.bd_src_el
diff ${M}_B.node ${MODEL_OUT_DIR}/${M}_B.node 
diff ${M}_B.element ${MODEL_OUT_DIR}/${M}_B.element 
diff ${M}_B.src_nd ${MODEL_OUT_DIR}/${M}_B.src_nd 
diff ${M}_B.bd_src_el ${MODEL_OUT_DIR}/${M}_B.bd_src_el
#
echo advautomesh_tetra3d_boundary2
${COMMAND_DIR}/advautomesh_tetra3d_boundary2 ${M}.node ${M}.element \
    ${M}.bd_fc \
    ${M}_B2.node ${M}_B2.element ${M}_B2.src_nd
diff ${M}_B2.node ${MODEL_OUT_DIR}/${M}_B2.node 
diff ${M}_B2.element ${MODEL_OUT_DIR}/${M}_B2.element 
diff ${M}_B2.src_nd ${MODEL_OUT_DIR}/${M}_B2.src_nd 
#
echo advautomesh_extract_value
${COMMAND_DIR}/advautomesh_extract_value 1 ${M}.scalar ${M}_B2.src_nd \
    ${M}_B2.scalar
diff ${M}_B2.scalar ${MODEL_OUT_DIR}/${M}_B2.scalar
#
echo advautomesh_extract_value
${COMMAND_DIR}/advautomesh_extract_value 3 ${M}.vector ${M}_B2.src_nd \
    ${M}_B2.vector
diff ${M}_B2.vector ${MODEL_OUT_DIR}/${M}_B2.vector
#
echo advautomesh_tri3d_edge
${COMMAND_DIR}/advautomesh_tri3d_edge ${M}_B2.node ${M}_B2.element \
    ${M}_B2.edge ${M}_B2.el_ed ${M}_B2.el_nb ${M}_B2.ed_vt
diff ${M}_B2.edge ${MODEL_OUT_DIR}/${M}_B2.edge 
diff ${M}_B2.el_ed ${MODEL_OUT_DIR}/${M}_B2.el_ed 
diff ${M}_B2.el_nb ${MODEL_OUT_DIR}/${M}_B2.el_nb 
diff ${M}_B2.ed_vt ${MODEL_OUT_DIR}/${M}_B2.ed_vt
#
echo advautomesh_tri3d_group
${COMMAND_DIR}/advautomesh_tri3d_group ${M}_B2.node ${M}_B2.element \
    ${M}_B2.edge ${M}_B2.el_ed ${M}_B2.el_nb ${M}_B2.ed_vt ${ANGLE} \
    ${M}_B2.el_gr ${M}_B2.ed_fr ${M}_B2.frame ${M}_B2.ed_fr_gr ${M}_B2.nd_fr_vt
diff ${M}_B2.el_gr ${MODEL_OUT_DIR}/${M}_B2.el_gr 
diff ${M}_B2.ed_fr ${MODEL_OUT_DIR}/${M}_B2.ed_fr 
diff ${M}_B2.frame ${MODEL_OUT_DIR}/${M}_B2.frame
diff ${M}_B2.ed_fr_gr ${MODEL_OUT_DIR}/${M}_B2.ed_fr_gr 
diff ${M}_B2.nd_fr_vt ${MODEL_OUT_DIR}/${M}_B2.nd_fr_vt 
#
echo advautomesh_tetra3d_divide
${COMMAND_DIR}/advautomesh_tetra3d_divide ${M}.node ${M}.element \
    ${M}.ed_vt ${M}.el_ed \
    ${M}_dv.node ${M}_dv.element ${M}_dv.dv_src_nd ${M}_dv.dv_src_el
diff ${M}_dv.node ${MODEL_OUT_DIR}/${M}_dv.node
diff ${M}_dv.element ${MODEL_OUT_DIR}/${M}_dv.element
diff ${M}_dv.dv_src_nd ${MODEL_OUT_DIR}/${M}_dv.dv_src_nd
diff ${M}_dv.dv_src_el ${MODEL_OUT_DIR}/${M}_dv.dv_src_el
#
echo advautomesh_tetra3d_generate_mid_node
${COMMAND_DIR}/advautomesh_tetra3d_generate_mid_node ${M}.node ${M}.element \
    ${M}.ed_vt ${M}.el_ed \
    ${M}_mng.node ${M}_mng.element10 ${M}_mng.mng_src_nd
diff ${M}_mng.node ${MODEL_OUT_DIR}/${M}_mng.node
diff ${M}_mng.element10 ${MODEL_OUT_DIR}/${M}_mng.element10
diff ${M}_mng.mng_src_nd ${MODEL_OUT_DIR}/${M}_mng.mng_src_nd
#
echo advautomesh_tetra3d_remove_mid_node
${COMMAND_DIR}/advautomesh_tetra3d_remove_mid_node ${M}_mng.node ${M}_mng.element10 \
    ${M}_mnr.node ${M}_mnr.element ${M}_mnr.src_nd
diff ${M}_mnr.node ${MODEL_OUT_DIR}/${M}_mnr.node
diff ${M}_mnr.element ${MODEL_OUT_DIR}/${M}_mnr.element
diff ${M}_mnr.src_nd ${MODEL_OUT_DIR}/${M}_mnr.src_nd



#
# echo advautomesh_tetra3d_extract
# ${COMMAND_DIR}/advautomesh_tetra3d_extract ${M}.node ${M}.element \
#    ${M}_xt.selection \
#    ${M}_xt.node ${M}_xt.element ${M}_xt.src_nd
# diff ${M}_xt.node ${MODEL_OUT_DIR}/${M}_xt.node
# diff ${M}_xt.element ${MODEL_OUT_DIR}/${M}_xt.element
# diff ${M}_xt.src_nd ${MODEL_OUT_DIR}/${M}_xt.src_nd
#
