M=$1

MODEL_IN_DIR=${M}_in
MODEL_OUT_DIR=${M}_out
COMMAND_DIR=../../command
VIEWER_DIR=../../autogl_command
ANGLE=30

cp ${MODEL_IN_DIR}/${M}.node .
cp ${MODEL_IN_DIR}/${M}.element .
cp ${MODEL_IN_DIR}/${M}.scalar .
cp ${MODEL_IN_DIR}/${M}.vector .
cp ${MODEL_IN_DIR}/${M}_xt.selection .

#
echo advautomesh_tri3d_edge
${COMMAND_DIR}/advautomesh_tri3d_edge ${M}.node ${M}.element \
    ${M}.edge ${M}.el_ed ${M}.el_nb ${M}.ed_vt
diff ${M}.edge ${MODEL_OUT_DIR}/${M}.edge 
diff ${M}.el_ed ${MODEL_OUT_DIR}/${M}.el_ed 
diff ${M}.el_nb ${MODEL_OUT_DIR}/${M}.el_nb 
diff ${M}.ed_vt ${MODEL_OUT_DIR}/${M}.ed_vt
#
echo advautomesh_tri3d_boundary_edge
${COMMAND_DIR}/advautomesh_tri3d_boundary_edge ${M}.node ${M}.element \
    ${M}.bd_ed
diff ${M}.bd_ed ${MODEL_OUT_DIR}/${M}.bd_ed
#
echo advautomesh_tri3d_group
${COMMAND_DIR}/advautomesh_tri3d_group ${M}.node ${M}.element \
    ${M}.edge ${M}.el_ed ${M}.el_nb ${M}.ed_vt ${ANGLE} \
    ${M}.el_gr ${M}.ed_fr ${M}.frame ${M}.ed_fr_gr ${M}.nd_fr_vt
diff ${M}.el_gr ${MODEL_OUT_DIR}/${M}.el_gr 
diff ${M}.ed_fr ${MODEL_OUT_DIR}/${M}.ed_fr 
diff ${M}.frame ${MODEL_OUT_DIR}/${M}.frame
diff ${M}.ed_fr_gr ${MODEL_OUT_DIR}/${M}.ed_fr_gr 
diff ${M}.nd_fr_vt ${MODEL_OUT_DIR}/${M}.nd_fr_vt 
#
echo advautomesh_tri3d_divide
${COMMAND_DIR}/advautomesh_tri3d_divide ${M}.node ${M}.element \
    ${M}.ed_vt ${M}.el_ed \
    ${M}_dv.node ${M}_dv.element ${M}_dv.dv_src_nd ${M}_dv.dv_src_el
diff ${M}_dv.node ${MODEL_OUT_DIR}/${M}_dv.node
diff ${M}_dv.element ${MODEL_OUT_DIR}/${M}_dv.element
diff ${M}_dv.dv_src_nd ${MODEL_OUT_DIR}/${M}_dv.dv_src_nd
diff ${M}_dv.dv_src_el ${MODEL_OUT_DIR}/${M}_dv.dv_src_el
#
echo advautomesh_tri3d_generate_mid_node
${COMMAND_DIR}/advautomesh_tri3d_generate_mid_node ${M}.node ${M}.element \
    ${M}.ed_vt ${M}.el_ed \
    ${M}_mng.node ${M}_mng.element6 ${M}_mng.mng_src_nd
diff ${M}_mng.node ${MODEL_OUT_DIR}/${M}_mng.node
diff ${M}_mng.element6 ${MODEL_OUT_DIR}/${M}_mng.element6
diff ${M}_mng.mng_src_nd ${MODEL_OUT_DIR}/${M}_mng.mng_src_nd
#
echo advautomesh_tri3d_remove_mid_node
${COMMAND_DIR}/advautomesh_tri3d_remove_mid_node ${M}_mng.node ${M}_mng.element6 \
    ${M}_mnr.node ${M}_mnr.element ${M}_mnr.src_nd
diff ${M}_mnr.node ${MODEL_OUT_DIR}/${M}_mnr.node
diff ${M}_mnr.element ${MODEL_OUT_DIR}/${M}_mnr.element
diff ${M}_mnr.src_nd ${MODEL_OUT_DIR}/${M}_mnr.src_nd
#
echo advautomesh_tri3d_extract
${COMMAND_DIR}/advautomesh_tri3d_extract ${M}.node ${M}.element \
    ${M}_xt.selection \
    ${M}_xt.node ${M}_xt.element ${M}_xt.src_nd
diff ${M}_xt.node ${MODEL_OUT_DIR}/${M}_xt.node
diff ${M}_xt.element ${MODEL_OUT_DIR}/${M}_xt.element
diff ${M}_xt.src_nd ${MODEL_OUT_DIR}/${M}_xt.src_nd

