#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

int main (int argc, char *argv[])
{
  FILE *nodeIn;
  FILE *scalarOut;
  FILE *vectorOut;
  int nNodes;
  int iNode;

  nodeIn = fopen (argv[1], "r");
  scalarOut = fopen (argv[2], "w");
  vectorOut = fopen (argv[3], "w");

  fscanf (nodeIn, "%d",
	  &nNodes);

  fprintf (scalarOut, "%d\n",
	   nNodes);
  fprintf (vectorOut, "%d\n",
	   nNodes);

  for (iNode = 0; iNode < nNodes; iNode++) {
    int nodeId;
    double x, y, z;
    double s;
    double u, v, w;

    fscanf (nodeIn, "%d %lf %lf %lf",
	    &nodeId, &x, &y, &z);

    s = sqrt (x * x + y * y + z * z);
    u = -y * 0.01;
    v = x * 0.01;
    w = 0.0;

    fprintf (scalarOut, "%d %f\n",
	     iNode, s);
    fprintf (vectorOut, "%d %f %f %f\n",
	     iNode, u, v, w);
  }

  fclose (nodeIn);
  fclose (scalarOut);
  fclose (vectorOut);
  


  return 0;
}
